'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _uiUtil = require('../utils/uiUtil');

var _arrayUtil = require('../utils/arrayUtil');

var _Sequence = require('../utils/Sequence');

var _Sequence2 = _interopRequireDefault(_Sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var List = function (_React$PureComponent) {
	_inherits(List, _React$PureComponent);

	function List() {
		_classCallCheck(this, List);

		var _this = _possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this));

		_this.onContainerTransitionEnd = function (event) {
			// Set state to NONE when hide animation done
			if (event.target !== _this.$container || _this.state.animateStatus !== _uiUtil.ANIMATE_STATUS_HIDING) return;
			_this.seq.next(function () {
				_this.setState({
					animateStatus: _uiUtil.ANIMATE_STATUS_NONE
				});
			});
		};

		_this.setContainerRef = function (ele) {
			_this.$container = ele;
		};

		_this.setListRef = function (ele) {
			_this.$list = ele;
		};

		_this.checkUpdate = function (prevProps, nextProps) {
			var list = nextProps.list,
			    rect = nextProps.rect;

			if (prevProps.list === list || !prevProps.list && !list) return;
			if (prevProps.list && list && (0, _arrayUtil.equals)(prevProps.list, list, ['value'])) return;

			if (!list || list.length === 0) {
				// Hide list
				_this.seq.next(function () {
					_this.setState({
						height: 0,
						animateStatus: _uiUtil.ANIMATE_STATUS_HIDING
					});
				});
			} else {
				// Show list
				var height = void 0;

				_this.seq.next(function (done) {
					_this.setState(function (preState) {
						var myState = {
							currentList: list,
							width: rect.width
						};

						if (preState.animateStatus === _uiUtil.ANIMATE_STATUS_NONE) {
							myState.animateStatus = _uiUtil.ANIMATE_STATUS_INIT;
						} else {
							myState.animateStatus = _uiUtil.ANIMATE_STATUS_SHOWING;
						}

						return myState;
					}, done);
				}).next(function (done) {
					var listRect = _this.$list.getBoundingClientRect();
					height = listRect.height;

					_this.setState(_extends({}, (0, _uiUtil.getEnablePosition)(rect, listRect, 'b')), done);
				}).next(function () {
					_this.setState({
						height: height,
						animateStatus: _uiUtil.ANIMATE_STATUS_SHOWN
					});
				});
			}
		};

		_this.state = {
			x: 0,
			y: 0,
			animateStatus: _uiUtil.ANIMATE_STATUS_NONE,

			height: 0,
			width: 0,
			currentList: null
		};

		_this.seq = new _Sequence2.default();
		return _this;
	}

	_createClass(List, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.checkUpdate({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.checkUpdate(this.props, nextProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _state = this.state,
			    currentList = _state.currentList,
			    height = _state.height,
			    width = _state.width,
			    animateStatus = _state.animateStatus,
			    x = _state.x,
			    y = _state.y;


			if (animateStatus === _uiUtil.ANIMATE_STATUS_NONE) return null;

			var selectedIndex = this.props.selectedIndex;


			return (0, _uiUtil.createPortal)(_react2.default.createElement(
				'div',
				{
					className: (0, _classnames2.default)('bmbo-auto-container', {
						'bmbo-init': animateStatus === _uiUtil.ANIMATE_STATUS_INIT,
						'bmbo-showing': animateStatus === _uiUtil.ANIMATE_STATUS_SHOWING,
						'bmbo-hiding': animateStatus === _uiUtil.ANIMATE_STATUS_HIDING
					}),
					style: {
						height: height + 'px',
						width: width + 'px',
						left: x + 'px',
						top: y + 'px'
					},

					ref: this.setContainerRef,
					onTransitionEnd: this.onContainerTransitionEnd
				},
				_react2.default.createElement(
					'ul',
					{ className: 'bmbo-auto-list', ref: this.setListRef },
					(currentList || []).map(function (_ref, index) {
						var value = _ref.value;
						return _react2.default.createElement(
							'li',
							{ key: index, className: (0, _classnames2.default)(selectedIndex === index && 'bmbo-active') },
							value
						);
					})
				)
			));
		}
	}]);

	return List;
}(_react2.default.PureComponent);

List.propTypes = {
	list: _propTypes2.default.array,
	selectedIndex: _propTypes2.default.number,
	rect: _propTypes2.default.object
};

exports.default = List;