'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _pathUtil = require('../utils/pathUtil');

var _Input = require('../Form/Input');

var _Input2 = _interopRequireDefault(_Input);

var _List = require('./List');

var _List2 = _interopRequireDefault(_List);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var KEY_UP = 38;
var KEY_DOWN = 40;
var KEY_ENTER = 13;
var OP_KEY_LIST = [KEY_UP, KEY_DOWN, KEY_ENTER];
var id = 0;

var AutoComplete = function (_React$PureComponent) {
	_inherits(AutoComplete, _React$PureComponent);

	function AutoComplete() {
		_classCallCheck(this, AutoComplete);

		var _this = _possibleConstructorReturn(this, (AutoComplete.__proto__ || Object.getPrototypeOf(AutoComplete)).call(this));

		_this.onKeyDown = function (nodeOnChange) {
			for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
				args[_key - 1] = arguments[_key];
			}

			var event = args[0];

			// Ignore if list is empty
			var _this$state = _this.state,
			    selectedIndex = _this$state.selectedIndex,
			    list = _this$state.list;

			if (!list || !list.length) return;

			// Check if is direct key
			var which = event.which;

			if (!OP_KEY_LIST.includes(which)) return;
			event.preventDefault();

			if (which === KEY_UP || which === KEY_DOWN) {
				// Move operation
				var myIndex = selectedIndex;
				if (which === 38) {
					myIndex -= 1;
				} else if (which === 40) {
					myIndex += 1;
				}
				myIndex = (myIndex + list.length) % list.length;

				_this.setState({
					selectedIndex: myIndex
				});
			} else if (which === KEY_ENTER) {
				// Select item
				event.target.value = list[selectedIndex].value;
				nodeOnChange.apply(undefined, args);

				_this.setState({
					selectedIndex: 0,
					list: null
				});
			}
		};

		_this.onKeyUp = function (event) {
			var which = event.which,
			    target = event.target;


			if (OP_KEY_LIST.includes(which)) return;

			var list = _this.getMatchList(target.value);

			_this.setState({
				list: list,
				rect: target.getBoundingClientRect()
			});
		};

		_this.onBlur = function () {
			_this.setState({
				selectedIndex: 0,
				list: null
			});
		};

		_this.getMatchList = function (str) {
			var matcher = _this.props.matcher;

			if (!matcher || !str) return null;

			var myStr = str.toUpperCase();

			if (Array.isArray(matcher)) {
				var len = matcher.length;
				var list = [];
				for (var i = 0; i < len; i += 1) {
					var cur = matcher[i];

					// String match
					if (typeof cur === 'string') {
						if (cur.toUpperCase().includes(myStr)) {
							list.push({ value: cur });
						}
					} else {
						var value = cur.value;

						if (String(value).toUpperCase().includes(myStr)) {
							list.push(cur);
						}
					}

					if (list.length >= 10) break;
				}

				return list;
			}

			return [];
		};

		_this.state = {
			list: null,
			selectedIndex: 0
		};

		_this.id = id;
		id += 1;
		return _this;
	}

	_createClass(AutoComplete, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    children = _props.children,
			    props = _objectWithoutProperties(_props, ['children']);

			var _state = this.state,
			    list = _state.list,
			    rect = _state.rect,
			    selectedIndex = _state.selectedIndex;


			delete props.matcher;

			var myChildren = children || _react2.default.createElement(_Input2.default, null);

			var $children = _react2.default.Children.map(myChildren, function (node) {
				var nodeOnKeyDown = (0, _pathUtil.getValue)(node, ['props', 'onKeyDown']);
				var nodeOnKeyUp = (0, _pathUtil.getValue)(node, ['props', 'onKeyUp']);
				var nodeOnBlur = (0, _pathUtil.getValue)(node, ['props', 'onBlur']);
				var nodeOnChange = (0, _pathUtil.getValue)(node, ['props', 'onChange']) || _this2.props.onChange;

				return _react2.default.cloneElement(node, _extends({}, props, {
					onKeyDown: function onKeyDown() {
						for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
							args[_key2] = arguments[_key2];
						}

						if (nodeOnKeyDown) nodeOnKeyDown.apply(undefined, args);
						_this2.onKeyDown.apply(_this2, [nodeOnChange].concat(args));
					},
					onKeyUp: function onKeyUp() {
						if (nodeOnKeyUp) nodeOnKeyUp.apply(undefined, arguments);
						_this2.onKeyUp.apply(_this2, arguments);
					},
					onBlur: function onBlur() {
						if (nodeOnBlur) nodeOnBlur.apply(undefined, arguments);
						_this2.onBlur.apply(_this2, arguments);
					}
				}));
			});

			return [].concat(_toConsumableArray($children), [_react2.default.createElement(_List2.default, { key: 'list_' + this.id, list: list, rect: rect, selectedIndex: selectedIndex })]);
		}
	}]);

	return AutoComplete;
}(_react2.default.PureComponent);

AutoComplete.propTypes = {
	children: _propTypes2.default.node,
	matcher: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.func]),
	onChange: _propTypes2.default.func
};

exports.default = AutoComplete;