'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Sequence = require('../utils/Sequence');

var _Sequence2 = _interopRequireDefault(_Sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DynamicNumber = function (_React$Component) {
	_inherits(DynamicNumber, _React$Component);

	function DynamicNumber() {
		_classCallCheck(this, DynamicNumber);

		var _this = _possibleConstructorReturn(this, (DynamicNumber.__proto__ || Object.getPrototypeOf(DynamicNumber)).call(this));

		_this.doAnimation = function (props) {
			var value = props.value,
			    duration = props.duration,
			    step = props.step,
			    decimal = props.decimal;

			var currentValue = Number(_this.state.current);

			// Ignore if value not change
			if (value === currentValue) {
				_this.seq.stop();
				return;
			}

			var startValue = isNaN(currentValue) ? 0 : currentValue;

			if (step) {
				// Use step
				var myStep = Math.abs(step);
				if (isNaN(myStep) || myStep === 0) myStep = 1;

				var frameStep = currentValue < value ? myStep : -myStep;
				var current = currentValue;

				_this.seq.next(function () {
					if (Math.abs(current - value) <= myStep) {
						_this.setState({ current: value.toFixed(decimal) });
						return false;
					}

					current += frameStep;
					_this.setState({ current: current.toFixed(decimal) });

					return null;
				}, {
					loop: true
				});
			} else {
				// Use duration
				var startTime = Date.now();

				_this.seq.next(function () {
					var currentTime = Date.now();
					var distance = currentTime - startTime;

					if (distance >= duration) {
						_this.setState({ current: value.toFixed(decimal) });
						return false;
					}

					var current = (startValue + (value - startValue) * (distance / duration)).toFixed(decimal);
					_this.setState({ current: current });

					return null;
				}, {
					loop: true
				});
			}
		};

		_this.state = {
			current: 0
		};

		_this.seq = new _Sequence2.default();
		return _this;
	}

	_createClass(DynamicNumber, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.doAnimation(this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.doAnimation(nextProps);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.seq.destroy();
		}
	}, {
		key: 'render',
		value: function render() {
			var current = this.state.current;

			var props = _extends({}, this.props);
			delete props.value;
			delete props.duration;
			delete props.decimal;
			delete props.step;

			return _react2.default.createElement(
				'span',
				props,
				current
			);
		}
	}]);

	return DynamicNumber;
}(_react2.default.Component);

DynamicNumber.propTypes = {
	value: _propTypes2.default.number,
	duration: _propTypes2.default.number,
	decimal: _propTypes2.default.number,
	step: _propTypes2.default.number
};

DynamicNumber.defaultProps = {
	duration: 1000,
	decimal: 0
};

exports.default = DynamicNumber;