'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _arrayUtil = require('../utils/arrayUtil');

var _eventUtil = require('../utils/eventUtil');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FlatList = function (_React$Component) {
	_inherits(FlatList, _React$Component);

	function FlatList() {
		_classCallCheck(this, FlatList);

		var _this = _possibleConstructorReturn(this, (FlatList.__proto__ || Object.getPrototypeOf(FlatList)).call(this));

		_this.onItemClick = function (event, level, itemValue) {
			var _this$props = _this.props,
			    value = _this$props.value,
			    onChange = _this$props.onChange;


			var myValue = (0, _arrayUtil.toArray)(value).slice(0, level);
			myValue[level] = itemValue;

			if (onChange) {
				onChange((0, _eventUtil.wrapperEventValue)(event, _this.$ele, myValue));
			}
		};

		_this.setRef = function (ele) {
			_this.$ele = ele;
		};

		_this.getMaxLevel = function () {
			return _this.props.columns || _this.state.maxLevel;
		};

		_this.getList = function () {
			var level = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
			var _this$props$list = _this.props.list,
			    list = _this$props$list === undefined ? [] : _this$props$list;
			var levelLists = _this.state.levelLists;


			if (level === 0) return list;

			return levelLists[level] || [];
		};

		_this.refreshList = function (prevProps, nextProps) {
			if (prevProps.value === nextProps.value && prevProps.list === nextProps.list) return;

			var _nextProps$list = nextProps.list,
			    list = _nextProps$list === undefined ? [] : _nextProps$list;

			var levelLists = {};
			var valueList = (0, _arrayUtil.toArray)(nextProps.value);

			var current = list;

			var _loop = function _loop(i) {
				var currentValue = valueList[i];
				current = current.find(function (_ref) {
					var value = _ref.value;
					return value === currentValue;
				});

				if (!current) {
					// Skip if path not match
					return 'break';
				}

				current = current.list || [];
				levelLists[i + 1] = current;
			};

			for (var i = 0; i < valueList.length; i += 1) {
				var _ret = _loop(i);

				if (_ret === 'break') break;
			}

			_this.setState({ levelLists: levelLists });
		};

		_this.state = {
			maxLevel: 1,
			levelLists: {}
		};
		return _this;
	}

	_createClass(FlatList, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.refreshList({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.refreshList(this.props, nextProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    size = _props.size,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['size', 'className']);

			delete props.value;
			delete props.list;
			delete props.multi;
			delete props.columns;
			delete props.onChange;

			var myValue = (0, _arrayUtil.toArray)(this.props.value);

			return _react2.default.createElement(
				'div',
				_extends({}, props, {
					className: (0, _classnames2.default)('bmbo-flat-list', 'bmbo-' + (size || 'md'), className),
					ref: this.setRef
				}),
				new Array(this.getMaxLevel()).fill(0).map(function (_, level) {
					var list = _this2.getList(level);
					var levelValue = myValue[level];

					return _react2.default.createElement(
						'ul',
						{
							key: level,
							className: 'bmbo-flat-list-column'
						},
						list.map(function (_ref2) {
							var title = _ref2.title,
							    value = _ref2.value;
							return _react2.default.createElement(
								'li',
								{
									className: (0, _classnames2.default)('bmbo-flat-list-item', levelValue === value && 'bmbo-active'),
									key: value
								},
								_react2.default.createElement(
									'span',
									{
										className: 'bmbo-padding',
										role: 'button',
										tabIndex: -1,
										onClick: function onClick(event) {
											_this2.onItemClick(event, level, value);
										}
									},
									title || value
								)
							);
						})
					);
				})
			);
		}
	}]);

	return FlatList;
}(_react2.default.Component);

FlatList.propTypes = {
	value: _propTypes2.default.node,
	list: _propTypes2.default.array,
	multi: _propTypes2.default.array,
	columns: _propTypes2.default.number,
	onChange: _propTypes2.default.func,

	size: _propTypes2.default.string,
	className: _propTypes2.default.string
};

exports.default = FlatList;