'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.BAMBOO_FORM_SELECT_GROUP = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.getNodeList = getNodeList;
exports.getValueList = getValueList;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Checkbox = require('./Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _componentUtil = require('../utils/componentUtil');

var _SelectOption = require('./SelectOption');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BAMBOO_FORM_SELECT_GROUP = exports.BAMBOO_FORM_SELECT_GROUP = 'BAMBOO_FORM_SELECT_GROUP';

function getNodeList() {
	var children = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	var parentProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	var valueList = [];

	(0, _componentUtil.mapChildrenByType)(children, _SelectOption.BAMBOO_FORM_SELECT_OPTION, function (node) {
		var _node$props = node.props,
		    nodeVal = _node$props.value,
		    nodeChildren = _node$props.children,
		    disabled = _node$props.disabled;

		var myVal = nodeVal !== undefined ? nodeVal : nodeChildren;
		valueList.push({
			title: nodeChildren,
			value: myVal,
			disabled: disabled !== undefined ? disabled : parentProps.disabled
		});
	});

	(0, _componentUtil.mapChildrenByType)(children, BAMBOO_FORM_SELECT_GROUP, function (node) {
		valueList = valueList.concat(getNodeList(node.props.children, node.props || {}));
	});

	return valueList;
}

function getValueList() {
	var children = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

	return getNodeList(children).map(function (_ref) {
		var value = _ref.value;
		return value;
	});
}

var SelectGroup = function (_React$Component) {
	_inherits(SelectGroup, _React$Component);

	function SelectGroup() {
		var _ref2;

		var _temp, _this, _ret;

		_classCallCheck(this, SelectGroup);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = SelectGroup.__proto__ || Object.getPrototypeOf(SelectGroup)).call.apply(_ref2, [this].concat(args))), _this), _this.selectAllValue = function (event) {
			var children = _this.props.children;
			var bmboOnSelectValues = _this.context.bmboOnSelectValues;

			var valueList = getValueList(children);

			bmboOnSelectValues(event, valueList, !_this.isAllSelected());
		}, _this.isAllSelected = function () {
			var children = _this.props.children;
			var bmboSelectIsChecked = _this.context.bmboSelectIsChecked;

			var valueList = getValueList(children);

			return valueList.every(bmboSelectIsChecked);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(SelectGroup, [{
		key: 'getChildContext',
		value: function getChildContext() {
			var bmboSelectDisabled = this.context.bmboSelectDisabled;


			return {
				bmboSelectDisabled: this.props.disabled !== undefined ? this.props.disabled : bmboSelectDisabled
			};
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    title = _props.title,
			    children = _props.children,
			    noSelectAll = _props.noSelectAll,
			    disabled = _props.disabled,
			    props = _objectWithoutProperties(_props, ['title', 'children', 'noSelectAll', 'disabled']);

			var _context = this.context,
			    bmboSelectMulti = _context.bmboSelectMulti,
			    bmboSelectSize = _context.bmboSelectSize,
			    bmboSelectDisabled = _context.bmboSelectDisabled;


			var myDisabled = void 0;
			if (disabled !== undefined) {
				myDisabled = disabled;
			} else if (bmboSelectDisabled !== undefined) {
				myDisabled = bmboSelectDisabled;
			}

			var $title = title;
			var selectAllProps = {};

			if (bmboSelectMulti && !noSelectAll) {
				$title = _react2.default.createElement(
					_Checkbox2.default,
					{ size: bmboSelectSize, disabled: myDisabled, checked: this.isAllSelected() },
					title
				);

				selectAllProps = {
					role: 'button',
					tabIndex: -1,
					onClick: myDisabled ? null : this.selectAllValue
				};
			} else {
				$title = _react2.default.createElement(
					'span',
					null,
					title
				);
			}

			return _react2.default.createElement(
				'li',
				_extends({
					className: 'bmbo-' + (bmboSelectSize || 'md') + ' bmbo-select-group'
				}, props),
				_react2.default.createElement(
					'div',
					_extends({
						className: 'bmbo-select-group-title bmbo-padding'
					}, selectAllProps),
					$title
				),
				_react2.default.createElement(
					'ul',
					null,
					children
				)
			);
		}
	}]);

	return SelectGroup;
}(_react2.default.Component);

SelectGroup.propTypes = {
	children: _propTypes2.default.node,
	title: _propTypes2.default.node,
	disabled: _propTypes2.default.bool,
	noSelectAll: _propTypes2.default.bool
};

SelectGroup.childContextTypes = {
	bmboSelectDisabled: _propTypes2.default.bool
};

SelectGroup.contextTypes = {
	bmboSelectSize: _propTypes2.default.string,
	bmboSelectMulti: _propTypes2.default.bool,
	bmboSelectDisabled: _propTypes2.default.bool,
	bmboOnSelectValue: _propTypes2.default.func,
	bmboOnSelectValues: _propTypes2.default.func,
	bmboSelectIsChecked: _propTypes2.default.func
};

SelectGroup[_componentUtil.BAMBOO_COMPONENT] = BAMBOO_FORM_SELECT_GROUP;

exports.default = SelectGroup;