'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.BAMBOO_FORM_SELECT_OPTION = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _componentUtil = require('../utils/componentUtil');

var _Checkbox = require('./Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BAMBOO_FORM_SELECT_OPTION = exports.BAMBOO_FORM_SELECT_OPTION = 'BAMBOO_FORM_SELECT_OPTION';

var SelectOption = function (_React$Component) {
	_inherits(SelectOption, _React$Component);

	function SelectOption() {
		_classCallCheck(this, SelectOption);

		var _this = _possibleConstructorReturn(this, (SelectOption.__proto__ || Object.getPrototypeOf(SelectOption)).call(this));

		_this.onClick = function () {
			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			var _this$props = _this.props,
			    onClick = _this$props.onClick,
			    value = _this$props.value,
			    children = _this$props.children;
			var bmboOnSelectValue = _this.context.bmboOnSelectValue;


			var myVal = value !== undefined ? value : children;

			if (bmboOnSelectValue) bmboOnSelectValue.apply(undefined, [myVal].concat(args));
			if (onClick) onClick.apply(undefined, args);
		};

		_this.state = {};
		return _this;
	}

	_createClass(SelectOption, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    disabled = _props.disabled,
			    value = _props.value,
			    children = _props.children,
			    props = _objectWithoutProperties(_props, ['disabled', 'value', 'children']);

			var _context = this.context,
			    bmboSelectMulti = _context.bmboSelectMulti,
			    bmboSelectDisabled = _context.bmboSelectDisabled,
			    bmboSelectSize = _context.bmboSelectSize,
			    bmboSelectIsChecked = _context.bmboSelectIsChecked;


			var myDisabled = void 0;
			if (disabled !== undefined) {
				myDisabled = disabled;
			} else if (bmboSelectDisabled !== undefined) {
				myDisabled = bmboSelectDisabled;
			}

			var $children = children;
			if (bmboSelectMulti) {
				$children = _react2.default.createElement(
					_Checkbox2.default,
					{
						size: bmboSelectSize,
						checked: bmboSelectIsChecked(value === undefined ? children : value),
						disabled: myDisabled
					},
					children
				);
			}

			return _react2.default.createElement(
				'li',
				_extends({
					role: 'button',
					tabIndex: -1,
					className: (0, _classnames2.default)('bmbo-select-item bmbo-padding', myDisabled && 'bmbo-disabled')
				}, props, {
					onClick: myDisabled ? null : this.onClick
				}),
				$children
			);
		}
	}]);

	return SelectOption;
}(_react2.default.Component);

SelectOption.propTypes = {
	onClick: _propTypes2.default.func,
	children: _propTypes2.default.node,
	value: _propTypes2.default.node,
	disabled: _propTypes2.default.bool
};

SelectOption.contextTypes = {
	bmboSelectSize: _propTypes2.default.string,
	bmboSelectMulti: _propTypes2.default.bool,
	bmboSelectDisabled: _propTypes2.default.bool,
	bmboOnSelectValue: _propTypes2.default.func,
	bmboSelectIsChecked: _propTypes2.default.func
};

SelectOption[_componentUtil.BAMBOO_COMPONENT] = BAMBOO_FORM_SELECT_OPTION;

exports.default = SelectOption;