'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _eventUtil = require('../utils/eventUtil');

var _envUtil = require('../utils/envUtil');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var currentSlider = void 0;

function getEventPercentage(holder, event) {
	var clientX = event.clientX;

	var _holder$getBoundingCl = holder.getBoundingClientRect(),
	    left = _holder$getBoundingCl.left,
	    width = _holder$getBoundingCl.width;

	var ptg = (clientX - left) / width;
	if (ptg < 0) ptg = 0;
	if (ptg > 1) ptg = 1;

	return ptg;
}

function getLeft(value, min, max) {
	var offset = value - min;
	var len = max - min;

	return offset / len * 100 + '%';
}

function valueSort(a, b) {
	return a - b;
}

if (_envUtil.canUseDOM) {
	window.addEventListener('mousemove', function (event) {
		if (!currentSlider) return;

		var ptg = getEventPercentage(currentSlider.$pinHolder, event);

		currentSlider.setValuePtg(ptg, event);
		event.preventDefault();
	});

	window.addEventListener('mouseup', function () {
		if (currentSlider) {
			currentSlider.pinIndex = undefined;
			currentSlider.finishUpdate();
			currentSlider = null;
		}
	});
}

var Pin = function (_React$Component) {
	_inherits(Pin, _React$Component);

	function Pin() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Pin);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Pin.__proto__ || Object.getPrototypeOf(Pin)).call.apply(_ref, [this].concat(args))), _this), _this.onMouseDown = function (event) {
			var _this$props = _this.props,
			    onMouseDown = _this$props.onMouseDown,
			    index = _this$props.index;

			if (onMouseDown) onMouseDown(event, index);
		}, _this.setRef = function (ele) {
			var _this$props2 = _this.props,
			    setRef = _this$props2.setRef,
			    index = _this$props2.index;

			if (setRef) setRef(ele, index);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Pin, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    left = _props.left,
			    index = _props.index,
			    isMark = _props.isMark,
			    isActive = _props.isActive;


			return _react2.default.createElement('div', {
				className: (0, _classnames2.default)('bmbo-slider-pin', isMark && 'bmbo-mark', isActive && 'bmbo-active'),
				onMouseDown: this.onMouseDown,
				style: { left: left },
				role: 'button',
				tabIndex: -1,
				ref: this.setRef,
				'data-index': index
			});
		}
	}]);

	return Pin;
}(_react2.default.Component);

Pin.propTypes = {
	setRef: _propTypes2.default.func,
	left: _propTypes2.default.string,
	index: _propTypes2.default.number,
	onMouseDown: _propTypes2.default.func,
	isMark: _propTypes2.default.bool,
	isActive: _propTypes2.default.bool
};

var Slider = function (_React$Component2) {
	_inherits(Slider, _React$Component2);

	function Slider() {
		_classCallCheck(this, Slider);

		var _this2 = _possibleConstructorReturn(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).call(this));

		_this2.onBarMouseDown = function () {
			for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
				args[_key2] = arguments[_key2];
			}

			var _this2$props = _this2.props,
			    disabled = _this2$props.disabled,
			    onMouseDown = _this2$props.onMouseDown,
			    value = _this2$props.value;

			if (disabled || _this2.getPinCount() > 1) return;

			if (onMouseDown) onMouseDown.apply(undefined, args);

			var event = args[0].nativeEvent;

			_this2.setState({
				value: value
			}, function () {
				_this2.pinIndex = 0;
				currentSlider = _this2;
				_this2.setValuePtg(getEventPercentage(_this2.$pinHolder, event), event);
			});
		};

		_this2.onPinMouseDown = function (event, index) {
			var _this2$props2 = _this2.props,
			    disabled = _this2$props2.disabled,
			    value = _this2$props2.value;

			if (disabled) return;

			_this2.setState({
				value: value
			}, function () {
				_this2.pinIndex = index;
				currentSlider = _this2;
			});

			event.stopPropagation();
		};

		_this2.setPinRef = function (ele, index) {
			_this2.$pins[index] = ele;
		};

		_this2.setPinHolderRef = function (ele) {
			_this2.$pinHolder = ele;
		};

		_this2.setValuePtg = function (ptg, event) {
			if (_this2.pinIndex === undefined) return;

			var onChange = _this2.props.onChange;

			var value = _this2.getValue();
			var _this2$props3 = _this2.props,
			    _this2$props3$min = _this2$props3.min,
			    min = _this2$props3$min === undefined ? 0 : _this2$props3$min,
			    _this2$props3$max = _this2$props3.max,
			    max = _this2$props3$max === undefined ? 100 : _this2$props3$max,
			    _this2$props3$step = _this2$props3.step,
			    step = _this2$props3$step === undefined ? 1 : _this2$props3$step;

			// Format number

			min = Number(min);
			max = Number(max);

			var len = max - min;
			var offset = void 0;
			var pinValue = void 0;

			var markValues = _this2.getMarkValues();

			if (step !== null) {
				step = Number(step);
				offset = Math.round(len * ptg / step) * step;
				pinValue = offset + min;

				// Stick mark if needed
				markValues.some(function (_ref2) {
					var markValue = _ref2.value,
					    stick = _ref2.stick;

					if (!stick) return false;

					if (markValue - stick <= pinValue && pinValue <= markValue + stick) {
						pinValue = markValue;
						return null;
					}

					return false;
				});
			} else {
				pinValue = min + len * ptg;
				var match = false;
				for (var i = markValues.length - 1; i > 0; i -= 1) {
					var cur = markValues[i].value;
					var prev = markValues[i - 1].value;
					if (pinValue >= prev) {
						match = true;
						pinValue = pinValue > (cur + prev) / 2 ? cur : prev;
						break;
					}
				}

				if (!match && markValues.length > 0) {
					pinValue = markValues[0].value;
				}
			}

			var newValue = void 0;
			if (Array.isArray(value)) {
				newValue = value.concat();
				newValue[_this2.pinIndex] = pinValue;
			} else if (_this2.getPinCount() === 1) {
				newValue = pinValue;
			} else {
				newValue = [];
				newValue[_this2.pinIndex] = pinValue;
			}

			var outputValue = newValue;

			// Clean up empty value
			if (Array.isArray(newValue)) {
				for (var _i = newValue.length - 1; _i >= 0; _i -= 1) {
					var val = newValue[_i];
					if (val === null || val === undefined) {
						newValue[_i] = min;
					}
				}

				outputValue = newValue.concat().sort(valueSort);
			}

			// Sync local value
			_this2.setState({
				value: newValue
			});

			var newEvent = (0, _eventUtil.wrapperEventValue)(event, _this2.$pins[_this2.pinIndex], outputValue);

			if (onChange) {
				onChange(newEvent);
			}
		};

		_this2.getMarkValues = function () {
			var _this2$props4 = _this2.props,
			    _this2$props4$min = _this2$props4.min,
			    min = _this2$props4$min === undefined ? 0 : _this2$props4$min,
			    _this2$props4$max = _this2$props4.max,
			    max = _this2$props4$max === undefined ? 100 : _this2$props4$max,
			    _this2$props4$marks = _this2$props4.marks,
			    marks = _this2$props4$marks === undefined ? {} : _this2$props4$marks;

			// No need to sort since number key is always in order

			return Object.keys(marks).map(function (markValue) {
				var value = Number(markValue);
				if (isNaN(value) || value < min || value > max) {
					console.warn('[Bamboo - Slider] Mark is out of range:', markValue, '(Range: ' + min + ' ~ ' + max);
					return null;
				}

				var config = marks[value];
				if (typeof config === 'string') {
					config = {
						title: config
					};
				}

				return _extends({}, config, {
					value: value
				});
			}).filter(function (n) {
				return n !== null;
			});
		};

		_this2.getPinCount = function () {
			var multi = _this2.props.multi;

			if (!multi) return 1;
			return multi === true ? 2 : Math.max(multi, 1);
		};

		_this2.getValue = function () {
			if (_this2.isOperating()) {
				return _this2.state.value;
			}
			return _this2.props.value;
		};

		_this2.getPinValue = function (index) {
			var value = _this2.getValue();
			var _this2$props5 = _this2.props,
			    _this2$props5$min = _this2$props5.min,
			    min = _this2$props5$min === undefined ? 0 : _this2$props5$min,
			    _this2$props5$max = _this2$props5.max,
			    max = _this2$props5$max === undefined ? 100 : _this2$props5$max;

			var current = void 0;

			if (Array.isArray(value)) {
				current = value[index];
			} else if (_this2.getPinCount() === 1) {
				current = value;
			} else {
				current = min;
			}

			min = Number(min);
			max = Number(max);
			current = Number(current);

			if (current === null || current === undefined || isNaN(current) || current < min) current = min;
			if (current > max) current = max;

			return current;
		};

		_this2.isOperating = function () {
			return currentSlider === _this2;
		};

		_this2.finishUpdate = function () {
			// Sync slider value with props value when user finish dragging
			Promise.resolve().then(function () {
				_this2.forceUpdate();
			});
		};

		_this2.$pins = {};
		_this2.state = {
			value: null // Component handle value when user is operating
		};
		return _this2;
	}

	_createClass(Slider, [{
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    _props2$min = _props2.min,
			    min = _props2$min === undefined ? 0 : _props2$min,
			    _props2$max = _props2.max,
			    max = _props2$max === undefined ? 100 : _props2$max,
			    disabled = _props2.disabled,
			    transparent = _props2.transparent,
			    type = _props2.type,
			    size = _props2.size,
			    className = _props2.className,
			    props = _objectWithoutProperties(_props2, ['min', 'max', 'disabled', 'transparent', 'type', 'size', 'className']);

			delete props.value;
			delete props.step;
			delete props.multi;
			delete props.marks;
			delete props.onMouseDown;
			delete props.onChange;

			var pinCount = this.getPinCount();

			var $pinList = [];
			var rangeMin = Number.MAX_VALUE;
			var rangeMax = Number.MIN_VALUE;

			for (var i = 0; i < pinCount; i += 1) {
				var value = this.getPinValue(i);

				// Pin list
				var left = getLeft(value, min, max);

				$pinList.push(_react2.default.createElement(Pin, {
					key: 'pin_' + i,
					index: i,
					setRef: this.setPinRef,
					onMouseDown: this.onPinMouseDown,
					left: left
				}));

				// Get limitation
				if (pinCount > 1) {
					rangeMin = Math.min(rangeMin, value);
				} else {
					rangeMin = min;
				}
				rangeMax = Math.max(rangeMax, value);
			}

			// Pin range
			var rangeWidthPtg = (rangeMax - rangeMin) / (max - min);

			// Marks
			var $markList = [];
			var $markTitleList = [];

			this.getMarkValues().forEach(function (_ref3) {
				var value = _ref3.value,
				    title = _ref3.title;

				var left = getLeft(value, min, max);

				// Mark
				$markList.push(_react2.default.createElement(Pin, {
					key: 'mark_' + value,
					left: left,
					isMark: true,
					isActive: rangeMin <= value && value <= rangeMax
				}));

				// Title
				$markTitleList.push(_react2.default.createElement(
					'div',
					{ key: 'title_' + value, className: 'bmbo-title-holder', style: { left: left } },
					_react2.default.createElement(
						'div',
						{ className: 'bmbo-title' },
						title
					)
				));
			});

			return _react2.default.createElement(
				'div',
				{
					className: (0, _classnames2.default)('bmbo-slider', pinCount === 1 && 'bmbo-single', 'bmbo-' + (type || 'primary'), 'bmbo-' + (size || 'md'), disabled && 'bmbo-disabled', transparent && 'bmbo-transparent', className),

					onMouseDown: this.onBarMouseDown
				},
				_react2.default.createElement(
					'div',
					{ className: 'bmbo-slider-content' },
					_react2.default.createElement('div', { className: 'bmbo-slider-bar', ref: this.setPinHolderRef }),
					_react2.default.createElement('div', {
						className: 'bmbo-slider-range',
						style: {
							left: getLeft(rangeMin, min, max),
							width: rangeWidthPtg * 100 + '%'
						}
					}),
					$markList,
					$pinList
				),
				_react2.default.createElement(
					'div',
					{ className: 'bmbo-slider-title' },
					$markTitleList
				)
			);
		}
	}]);

	return Slider;
}(_react2.default.Component);

Slider.propTypes = {
	className: _propTypes2.default.string,
	value: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.array]),
	min: _propTypes2.default.number,
	max: _propTypes2.default.number,
	step: _propTypes2.default.number,
	type: _propTypes2.default.string,
	size: _propTypes2.default.string,
	transparent: _propTypes2.default.bool,
	disabled: _propTypes2.default.bool,
	multi: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.number]),
	marks: _propTypes2.default.object,

	onMouseDown: _propTypes2.default.func,
	onChange: _propTypes2.default.func
};

exports.default = Slider;