'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Col = require('./Col');

var _Col2 = _interopRequireDefault(_Col);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_GUTTER = 15;

var Row = function (_React$PureComponent) {
	_inherits(Row, _React$PureComponent);

	function Row() {
		_classCallCheck(this, Row);

		return _possibleConstructorReturn(this, (Row.__proto__ || Object.getPrototypeOf(Row)).apply(this, arguments));
	}

	_createClass(Row, [{
		key: 'getChildContext',
		value: function getChildContext() {
			var _props$gutter = this.props.gutter,
			    gutter = _props$gutter === undefined ? DEFAULT_GUTTER : _props$gutter;


			return {
				rowGutter: gutter
			};
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    _props$gutter2 = _props.gutter,
			    gutter = _props$gutter2 === undefined ? DEFAULT_GUTTER : _props$gutter2,
			    children = _props.children,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['gutter', 'children', 'className']);

			var hg = gutter / 2;

			return _react2.default.createElement(
				'div',
				_extends({ className: (0, _classnames2.default)('bmbo-row', className) }, props),
				_react2.default.createElement(
					'div',
					{ style: { marginLeft: '-' + hg + 'px', marginRight: '-' + hg + 'px' } },
					children
				)
			);
		}
	}]);

	return Row;
}(_react2.default.PureComponent);

Row.propTypes = {
	gutter: _propTypes2.default.number,
	children: _propTypes2.default.node,
	className: _propTypes2.default.string
};

Row.childContextTypes = {
	rowGutter: _propTypes2.default.number
};

Row.Col = _Col2.default;

exports.default = Row;