'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.BAMBOO_GROUP_ITEM = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _componentUtil = require('../utils/componentUtil');

var _eventUtil = require('../utils/eventUtil');

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Radio = require('../Form/Radio');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BAMBOO_GROUP_ITEM = exports.BAMBOO_GROUP_ITEM = 'BAMBOO_GROUP_ITEM';

var Item = function (_React$Component) {
	_inherits(Item, _React$Component);

	function Item() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Item);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Item.__proto__ || Object.getPrototypeOf(Item)).call.apply(_ref, [this].concat(args))), _this), _this.setRef = function (ele) {
			_this.$ele = ele;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Item, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    _props$style = _props.style,
			    style = _props$style === undefined ? {} : _props$style,
			    width = _props.width,
			    children = _props.children,
			    isFirst = _props.isFirst,
			    isLast = _props.isLast,
			    value = _props.value,
			    onChange = _props.onChange,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['style', 'width', 'children', 'isFirst', 'isLast', 'value', 'onChange', 'className']);

			if (width) style.width = width;

			var $child = _react2.default.Children.only(children);

			if (_react2.default.isValidElement($child) && $child.type && $child.type[_componentUtil.BAMBOO_COMPONENT] === _Radio.BAMBOO_FORM_RADIO) {
				var _$child$props = $child.props,
				    _onClick = _$child$props.onClick,
				    type = _$child$props.type,
				    transparent = _$child$props.transparent,
				    restProps = _objectWithoutProperties(_$child$props, ['onClick', 'type', 'transparent']);

				var checked = restProps.value === value;

				$child = _react2.default.createElement(_Button2.default, _extends({
					checked: checked,
					type: checked || !transparent ? type : 'weak',
					transparent: transparent
				}, restProps, {
					ref: this.setRef,
					onClick: function onClick() {
						var event = arguments.length <= 0 ? undefined : arguments[0];
						if (onChange) onChange((0, _eventUtil.wrapperEventValue)(event, _this2.$ele, restProps.value));
						if (_onClick) _onClick.apply(undefined, arguments);
					}
				}));
			}

			return _react2.default.createElement(
				'div',
				_extends({
					className: (0, _classnames2.default)('bmbo-group-item', {
						'bmbo-first': isFirst && !isLast,
						'bmbo-last': isLast && !isFirst,
						'bmbo-middle': !isFirst && !isLast,
						className: className
					}),
					style: style
				}, props),
				$child
			);
		}
	}]);

	return Item;
}(_react2.default.Component);

Item.propTypes = {
	children: _propTypes2.default.node,
	className: _propTypes2.default.string,
	style: _propTypes2.default.object,
	width: _propTypes2.default.string,
	isFirst: _propTypes2.default.bool,
	isLast: _propTypes2.default.bool,
	value: _propTypes2.default.node,
	onChange: _propTypes2.default.func
};

Item[_componentUtil.BAMBOO_COMPONENT] = BAMBOO_GROUP_ITEM;

exports.default = Item;