'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _componentUtil = require('../utils/componentUtil');

var _Item = require('./Item');

var _Item2 = _interopRequireDefault(_Item);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Group = function Group(_ref) {
	var children = _ref.children,
	    value = _ref.value,
	    onChange = _ref.onChange,
	    _ref$style = _ref.style,
	    style = _ref$style === undefined ? {} : _ref$style,
	    width = _ref.width,
	    className = _ref.className,
	    props = _objectWithoutProperties(_ref, ['children', 'value', 'onChange', 'style', 'width', 'className']);

	var myStyle = _extends({}, style);
	if (width) myStyle.width = width;

	// Wrap component with Item
	var itemList = (0, _componentUtil.mapChildrenForNode)(children, function (node) {
		var item = node;
		if (!node.type || node.type[_componentUtil.BAMBOO_COMPONENT] !== _Item.BAMBOO_GROUP_ITEM) {
			item = _react2.default.createElement(
				_Item2.default,
				null,
				node
			);
		}

		return item;
	}).filter(function (n) {
		return n;
	});
	var count = itemList.length;

	// Mark first & last Item
	var $children = itemList.map(function (node, index) {
		return _react2.default.cloneElement(node, {
			isFirst: index === 0,
			isLast: index === count - 1,
			value: value,
			onChange: onChange
		});
	});

	return _react2.default.createElement(
		'div',
		_extends({
			className: (0, _classnames2.default)('bmbo-group', className),
			style: myStyle
		}, props),
		$children
	);
};

Group.propTypes = {
	children: _propTypes2.default.node,
	className: _propTypes2.default.string,
	value: _propTypes2.default.node,
	onChange: _propTypes2.default.func,
	style: _propTypes2.default.object,
	width: _propTypes2.default.string
};

Group.Item = _Item2.default;

exports.default = Group;