'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Label = function Label(_ref) {
	var type = _ref.type,
	    size = _ref.size,
	    className = _ref.className,
	    children = _ref.children,
	    props = _objectWithoutProperties(_ref, ['type', 'size', 'className', 'children']);

	return _react2.default.createElement(
		'span',
		_extends({
			className: (0, _classnames2.default)('bmbo-label', 'bmbo-' + (type || 'primary'), 'bmbo-' + (size || 'md'), className)
		}, props),
		children
	);
};

Label.propTypes = {
	children: _propTypes2.default.node,

	type: _propTypes2.default.string,
	className: _propTypes2.default.string,
	size: _propTypes2.default.string,
	disabled: _propTypes2.default.bool,
	onClick: _propTypes2.default.func,
	transparent: _propTypes2.default.bool,
	checked: _propTypes2.default.bool
};

exports.default = Label;