'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _uiUtil = require('../utils/uiUtil');

var _Sequence = require('../utils/Sequence');

var _Sequence2 = _interopRequireDefault(_Sequence);

var _MenuItem = require('./MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuList = function (_React$Component) {
	_inherits(MenuList, _React$Component);

	function MenuList() {
		_classCallCheck(this, MenuList);

		var _this = _possibleConstructorReturn(this, (MenuList.__proto__ || Object.getPrototypeOf(MenuList)).call(this));

		_this.onMouseDown = function (event) {
			event.stopPropagation();
		};

		_this.setRef = function (ele) {
			_this.$list = ele;
		};

		_this.state = {
			animateStatus: _uiUtil.ANIMATE_STATUS_NONE
		};
		_this.seq = new _Sequence2.default();
		return _this;
	}

	_createClass(MenuList, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this2 = this;

			var _props = this.props,
			    x = _props.x,
			    y = _props.y,
			    _props$width = _props.width,
			    width = _props$width === undefined ? 0 : _props$width,
			    _props$height = _props.height,
			    height = _props$height === undefined ? 0 : _props$height;

			var rect = this.$list.getBoundingClientRect();

			this.seq.next(function () {
				_this2.setState(_extends({}, (0, _uiUtil.getEnablePosition)({ left: x, top: y, width: width, height: height }, rect, 'r'), {
					animateStatus: _uiUtil.ANIMATE_STATUS_SHOWING
				}));
			}).next(function () {
				_this2.setState({
					animateStatus: _uiUtil.ANIMATE_STATUS_SHOWN
				});
			});
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.seq.destroy();
		}
	}, {
		key: 'render',
		value: function render() {
			var _props$list = this.props.list,
			    list = _props$list === undefined ? [] : _props$list;
			var menuSize = this.context.menuSize;
			var _state = this.state,
			    x = _state.x,
			    y = _state.y,
			    animateStatus = _state.animateStatus;


			return (0, _uiUtil.createPortal)(_react2.default.createElement(
				'ul',
				{
					ref: this.setRef,
					className: (0, _classnames2.default)('bmbo-box-absolute', 'bmbo-menu-list', {
						'bmbo-hidden': animateStatus === _uiUtil.ANIMATE_STATUS_NONE,
						'bmbo-showing': animateStatus === _uiUtil.ANIMATE_STATUS_SHOWING
					}, 'bmbo-' + (menuSize || 'md')),
					style: { left: x + 'px', top: y + 'px' },
					role: 'presentation',
					tabIndex: -1,
					onMouseDown: this.onMouseDown
				},
				list.map(function (item, index) {
					if (!item) return null;
					return _react2.default.createElement(_MenuItem2.default, { key: index, item: item });
				})
			));
		}
	}]);

	return MenuList;
}(_react2.default.Component);

MenuList.propTypes = {
	list: _propTypes2.default.array,
	x: _propTypes2.default.number,
	y: _propTypes2.default.number,
	width: _propTypes2.default.number,
	height: _propTypes2.default.number
};

MenuList.contextTypes = {
	menuSize: _propTypes2.default.string
};

exports.default = MenuList;