'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.BAMBOO_MODAL_PREFACE = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _componentUtil = require('../utils/componentUtil');

var _uiUtil = require('../utils/uiUtil');

var _Sequence = require('../utils/Sequence');

var _Sequence2 = _interopRequireDefault(_Sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BAMBOO_MODAL_PREFACE = exports.BAMBOO_MODAL_PREFACE = 'BAMBOO_MODAL_PREFACE';

var ModalPreface = function (_React$Component) {
	_inherits(ModalPreface, _React$Component);

	function ModalPreface() {
		_classCallCheck(this, ModalPreface);

		var _this = _possibleConstructorReturn(this, (ModalPreface.__proto__ || Object.getPrototypeOf(ModalPreface)).call(this));

		_this.setContentRef = function (ele) {
			_this.$content = ele;
		};

		_this.checkUpdate = function (preProps, nextProps) {
			if (!preProps.visible !== !nextProps.visible) {
				if (nextProps.visible) {
					var _nextProps$delay = nextProps.delay,
					    delay = _nextProps$delay === undefined ? 400 : _nextProps$delay;

					// Show preface

					_this.seq.next(function () {
						_this.setState({
							animateStatus: _uiUtil.ANIMATE_STATUS_SHOWING,
							contentWidth: 0
						});
					}).next(function () {
						var newState = { animateStatus: _uiUtil.ANIMATE_STATUS_SHOWN };

						if (_this.$content) {
							newState.contentWidth = _this.$content.scrollWidth;
						}

						_this.setState(newState);
					}, { delay: delay });
				} else {
					// Hide preface
					_this.seq.next(function () {
						_this.setState({
							animateStatus: _uiUtil.ANIMATE_STATUS_NONE
						});
					});
				}
			}
		};

		_this.state = {
			animateStatus: _uiUtil.ANIMATE_STATUS_NONE,
			contentWidth: 0
		};
		_this.seq = new _Sequence2.default();
		return _this;
	}

	_createClass(ModalPreface, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.checkUpdate({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.checkUpdate(this.props, nextProps);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.seq.destroy();
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['children', 'className']);

			var _state = this.state,
			    animateStatus = _state.animateStatus,
			    contentWidth = _state.contentWidth;


			delete props.delay;
			delete props.visible;

			return _react2.default.createElement(
				'div',
				_extends({
					className: (0, _classnames2.default)('bmbo-modal-preface', {
						'bmbo-showing': animateStatus === _uiUtil.ANIMATE_STATUS_SHOWING,
						className: className
					}),
					style: { width: contentWidth ? contentWidth + 'px' : null }
				}, props),
				_react2.default.createElement(
					'div',
					{ className: 'bmbo-modal-preface-content', ref: this.setContentRef },
					children
				)
			);
		}
	}]);

	return ModalPreface;
}(_react2.default.Component);

ModalPreface.propTypes = {
	delay: _propTypes2.default.number,
	children: _propTypes2.default.node,
	className: _propTypes2.default.string,
	visible: _propTypes2.default.bool // eslint-disable-line react/no-unused-prop-types
};

ModalPreface[_componentUtil.BAMBOO_COMPONENT] = BAMBOO_MODAL_PREFACE;

exports.default = ModalPreface;