'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var NavItem = function NavItem(_ref) {
	var children = _ref.children,
	    onClick = _ref.onClick,
	    active = _ref.active,
	    disabled = _ref.disabled,
	    className = _ref.className,
	    props = _objectWithoutProperties(_ref, ['children', 'onClick', 'active', 'disabled', 'className']);

	return _react2.default.createElement(
		'li',
		_extends({
			className: (0, _classnames2.default)('bmbo-nav-item', active && 'bmbo-active', disabled && 'bmbo-disabled', className),
			role: 'button',
			tabIndex: -1,
			onClick: onClick
		}, props),
		children
	);
};

NavItem.propTypes = {
	children: _propTypes2.default.node,
	onClick: _propTypes2.default.func,
	className: _propTypes2.default.string,

	active: _propTypes2.default.bool,
	disabled: _propTypes2.default.bool
};

exports.default = NavItem;