'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _uiUtil = require('../utils/uiUtil');

var _Sequence = require('../utils/Sequence');

var _Sequence2 = _interopRequireDefault(_Sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DRILL_SPEED = 4 / 5;

var NavList = function (_React$Component) {
	_inherits(NavList, _React$Component);

	function NavList() {
		_classCallCheck(this, NavList);

		var _this = _possibleConstructorReturn(this, (NavList.__proto__ || Object.getPrototypeOf(NavList)).call(this));

		_this.onTransitionEnd = function (event) {
			if (_this.state.animateStatus === _uiUtil.ANIMATE_STATUS_HIDING && event.target === _this.$list) {
				_this.seq.next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_NONE });
				});
			}
		};

		_this.setListRef = function (ele) {
			var setRef = _this.props.setRef;

			_this.$list = ele;
			setRef(ele);
		};

		_this.checkUpdate = function (prevProps, nextProps) {
			if (_this.context.navInline) {
				if (!prevProps.open === !nextProps.open) return;
				_this.doDrillAnimation(nextProps);
			} else {
				if (!prevProps.visible === !nextProps.visible) return;
				_this.doFloatAnimation(nextProps);
			}
		};

		_this.doDrillAnimation = function (props) {
			if (props.open) {
				_this.seq.next(function () {
					_this.setState({
						height: 0
					});
				}).next(function () {
					var clientHeight = _this.$list.clientHeight;
					var scrollHeight = _this.$list.scrollHeight;

					var currentHeight = Math.ceil(clientHeight * DRILL_SPEED + scrollHeight * (1 - DRILL_SPEED));
					if (scrollHeight - currentHeight <= 1) {
						currentHeight = scrollHeight;
						_this.setState({ height: null });
						return false;
					}

					_this.setState({ height: currentHeight });

					return null;
				}, {
					loop: true,
					frame: 1
				});
			} else {
				_this.seq.next(function () {
					_this.setState({
						height: null
					});
				}).next(function () {
					var clientHeight = _this.$list.clientHeight;

					var currentHeight = Math.floor(clientHeight * DRILL_SPEED);
					if (clientHeight <= 1) {
						_this.setState({ height: 0 });
						return false;
					}

					_this.setState({ height: currentHeight });

					return null;
				}, {
					loop: true,
					frame: 1
				});
			}
		};

		_this.doFloatAnimation = function (props) {
			if (props.visible) {
				_this.seq.next(function () {
					_this.setState({
						animateStatus: _uiUtil.ANIMATE_STATUS_INIT,
						x: 0,
						y: 0
					});
				}).next(function () {
					var rect = _this.props.rect;
					var navVertical = _this.context.navVertical;

					var listRect = _this.$list.getBoundingClientRect();

					var pos = navVertical ? 'r' : 'b';

					// Add offset to let nav list match with parent
					var superRect = {
						left: rect.left,
						top: rect.top,
						width: rect.width,
						height: rect.height
					};
					if (navVertical) {
						superRect.top -= 1;
						superRect.height += 2;
					} else {
						superRect.left -= 1;
						superRect.width += 2;
					}

					_this.setState(_extends({}, (0, _uiUtil.getEnablePosition)(superRect, listRect, pos), {
						animateStatus: _uiUtil.ANIMATE_STATUS_SHOWING
					}));
				}).next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_SHOWN });
				});
			} else {
				_this.seq.next(function () {
					var animateStatus = _this.state.animateStatus;

					if (animateStatus === _uiUtil.ANIMATE_STATUS_NONE || animateStatus === _uiUtil.ANIMATE_STATUS_INIT) {
						return false;
					}
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_HIDING });
					return null;
				}).next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_NONE });
				}, { delay: 1000 });
			}
		};

		_this.state = {
			animateStatus: _uiUtil.ANIMATE_STATUS_NONE,
			x: 0,
			y: 0,
			height: 0
		};
		_this.seq = new _Sequence2.default();
		return _this;
	}

	_createClass(NavList, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.checkUpdate({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.checkUpdate(this.props, nextProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    rect = _props.rect;
			var _context = this.context,
			    navType = _context.navType,
			    navVertical = _context.navVertical,
			    navInline = _context.navInline;
			var _state = this.state,
			    animateStatus = _state.animateStatus,
			    x = _state.x,
			    y = _state.y,
			    height = _state.height;


			if (!navVertical || !navInline) {
				// Float display

				if (animateStatus === _uiUtil.ANIMATE_STATUS_NONE) return null;

				return (0, _uiUtil.createPortal)(_react2.default.createElement(
					'div',
					{
						className: (0, _classnames2.default)('bmbo-nav-list', {
							'bmbo-hidden': animateStatus === _uiUtil.ANIMATE_STATUS_INIT,
							'bmbo-showing': animateStatus === _uiUtil.ANIMATE_STATUS_SHOWING,
							'bmbo-hiding': animateStatus === _uiUtil.ANIMATE_STATUS_HIDING
						}, 'bmbo-' + (navType || 'lead')),
						ref: this.setListRef,
						style: { left: x + 'px', top: y + 'px', minWidth: rect.width + 'px' },
						onTransitionEnd: this.onTransitionEnd
					},
					children
				));
			}

			// Inline display
			var style = {};
			if (height !== null) {
				style.height = height + 'px';
			}

			return _react2.default.createElement(
				'ul',
				{
					className: 'bmbo-nav-list',
					style: style,
					ref: this.setListRef
				},
				children
			);
		}
	}]);

	return NavList;
}(_react2.default.Component);

NavList.propTypes = {
	visible: _propTypes2.default.bool,
	open: _propTypes2.default.bool,
	rect: _propTypes2.default.object,

	setRef: _propTypes2.default.func,

	children: _propTypes2.default.node
};

NavList.contextTypes = {
	navType: _propTypes2.default.string,
	navVertical: _propTypes2.default.bool,
	navInline: _propTypes2.default.bool
};

exports.default = NavList;