'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var DatePanel = function DatePanel(_ref) {
	var date = _ref.date,
	    viewDate = _ref.viewDate,
	    startDate = _ref.startDate,
	    endDate = _ref.endDate,
	    triggerChangeEvent = _ref.triggerChangeEvent,
	    className = _ref.className,
	    setRef = _ref.setRef,
	    props = _objectWithoutProperties(_ref, ['date', 'viewDate', 'startDate', 'endDate', 'triggerChangeEvent', 'className', 'setRef']);

	var $dateList = [];
	var currentDate = startDate.clone();

	var _loop = function _loop() {
		var pointDate = currentDate.clone();

		$dateList.push(_react2.default.createElement(
			'li',
			{
				key: pointDate.format('YYYY-MM-DD'),
				className: (0, _classnames2.default)({
					'bmbo-deprecated': viewDate && pointDate.getMonth() !== viewDate.getMonth(),
					'bmbo-active': date && pointDate.getFullYear() === date.getFullYear() && pointDate.getMonth() === date.getMonth() && pointDate.getDate() === date.getDate()
				}),
				role: 'button',
				tabIndex: -1,
				onClick: function onClick(event) {
					triggerChangeEvent(event, pointDate);
				}
			},
			pointDate.getDate()
		));

		currentDate.setDate(currentDate.getDate() + 1);
	};

	while (currentDate.getTime() <= endDate.getTime()) {
		_loop();
	}

	return _react2.default.createElement(
		'ul',
		_extends({ className: (0, _classnames2.default)('bmbo-date-picker-panel', className), ref: setRef }, props),
		$dateList
	);
};

DatePanel.propTypes = {
	date: _propTypes2.default.object,
	viewDate: _propTypes2.default.object,
	startDate: _propTypes2.default.object,
	endDate: _propTypes2.default.object,
	className: _propTypes2.default.string,
	triggerChangeEvent: _propTypes2.default.func,
	setRef: _propTypes2.default.func
};

exports.default = DatePanel;