'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _dateUtils = require('../utils/dateUtils');

var _eventUtil = require('../utils/eventUtil');

var _envUtil = require('../utils/envUtil');

var _uiUtil = require('../utils/uiUtil');

var _Sequence = require('../utils/Sequence');

var _Sequence2 = _interopRequireDefault(_Sequence);

var _DatePanel = require('./DatePanel');

var _DatePanel2 = _interopRequireDefault(_DatePanel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DATE_LIST = ['SUN', 'MON', 'TUE', 'WED', 'THU', 'FRI', 'SAT'];

var DatePicker = function (_React$Component) {
	_inherits(DatePicker, _React$Component);

	function DatePicker() {
		_classCallCheck(this, DatePicker);

		var _this = _possibleConstructorReturn(this, (DatePicker.__proto__ || Object.getPrototypeOf(DatePicker)).call(this));

		_this.onSwitchDateView = function (nextDate) {
			if (_this.state.animateStatus !== _uiUtil.ANIMATE_STATUS_NONE) return;
			_this.switchDateView(nextDate);
		};

		_this.onTransitionEnd = function (event) {
			var _this$state = _this.state,
			    animateStatus = _this$state.animateStatus,
			    nextViewDate = _this$state.nextViewDate;


			if (event.target === _this.$nextView && animateStatus === _uiUtil.ANIMATE_STATUS_SHOWN) {
				_this.seq.next(function () {
					_this.setState({
						animateStatus: _uiUtil.ANIMATE_STATUS_NONE,
						viewDate: nextViewDate,
						nextViewDate: null
					});
				});
			}
		};

		_this.setRef = function (ele) {
			_this.$ele = ele;
		};

		_this.setViewRef = function (ele) {
			_this.$view = ele;
		};

		_this.setNextViewRef = function (ele) {
			_this.$nextView = ele;
		};

		_this.checkUpdate = function (prevProps, nextProps) {
			if (prevProps.value === nextProps.value) return;

			var viewDate = _this.state.viewDate;

			var nextDate = new _dateUtils.BambooDate(nextProps.value);

			if (!prevProps.value || viewDate && viewDate.format('YYYY-MM') === nextDate.format('YYYY-MM')) {
				_this.setState({
					viewDate: nextDate
				});
			} else {
				var prevDate = new _dateUtils.BambooDate(prevProps.value);
				if (prevDate.format('YYYY-MM') === nextDate.format('YYYY-MM')) return;

				_this.switchDateView(nextDate);
			}
		};

		_this.switchDateView = function (nextDate) {
			_this.seq.next(function (done) {
				_this.setState({
					animateStatus: _uiUtil.ANIMATE_STATUS_SHOWING,
					nextViewDate: nextDate
				}, done);
			}).next(function (done) {
				_this.setState({
					animateStatus: _uiUtil.ANIMATE_STATUS_SHOWN
				}, done);
			});
		};

		_this.triggerChangeEvent = function (event, date) {
			var onChange = _this.props.onChange;

			if (onChange) {
				onChange((0, _eventUtil.wrapperEventValue)(event, _this.$ele, date.format('YYYY-MM-DD')));
			}
		};

		_this.state = {
			animateStatus: _uiUtil.ANIMATE_STATUS_NONE,

			viewDate: null, // This is used for show current year-month panel
			nextViewDate: null // This is used for animation panel
		};

		_this.seq = new _Sequence2.default();
		return _this;
	}

	_createClass(DatePicker, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.checkUpdate({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.checkUpdate(this.props, nextProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _state = this.state,
			    animateStatus = _state.animateStatus,
			    viewDate = _state.viewDate,
			    nextViewDate = _state.nextViewDate;

			if (!viewDate) return null;

			var _props = this.props,
			    value = _props.value,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['value', 'className']);

			delete props.onChange;

			var date = new _dateUtils.BambooDate(value);

			var isShowing = animateStatus === _uiUtil.ANIMATE_STATUS_SHOWING;
			var isShown = animateStatus === _uiUtil.ANIMATE_STATUS_SHOWN;

			// Current view
			var startDate = viewDate.clone().setDate(1);
			var endDate = viewDate.clone().setDate(1);
			startDate.setDay(0);
			endDate.setMonth(endDate.getMonth() + 1).setDate(0).setDay(6);
			var $view = _react2.default.createElement(_DatePanel2.default, {
				date: date,
				viewDate: viewDate,
				startDate: startDate,
				endDate: endDate,
				triggerChangeEvent: this.triggerChangeEvent,
				setRef: this.setViewRef,
				className: (0, _classnames2.default)({
					'bmbo-left': isShown && nextViewDate.getTime() > viewDate.getTime(),
					'bmbo-right': isShown && nextViewDate.getTime() < viewDate.getTime()
				})
			});

			// Next view
			var $nextView = void 0;
			if (animateStatus !== _uiUtil.ANIMATE_STATUS_NONE) {
				var nextStartDate = nextViewDate.clone().setDate(1);
				var nextEndDate = nextViewDate.clone().setDate(1);
				nextStartDate.setDay(0);
				nextEndDate.setMonth(nextEndDate.getMonth() + 1).setDate(0).setDay(6);
				$nextView = _react2.default.createElement(_DatePanel2.default, {
					date: date,
					viewDate: nextViewDate,
					startDate: nextStartDate,
					endDate: nextEndDate,
					setRef: this.setNextViewRef,
					onTransitionEnd: this.onTransitionEnd,
					className: (0, _classnames2.default)('bmbo-target', {
						'bmbo-left': isShowing && nextViewDate.getTime() < viewDate.getTime(),
						'bmbo-right': isShowing && nextViewDate.getTime() > viewDate.getTime()
					})
				});
			}

			// Content style
			var contentStyle = {};
			if (_envUtil.canUseDOM) {
				if (isShowing && this.$view) {
					contentStyle.height = this.$view.clientHeight + 'px';
				} else if (!isShowing && this.$nextView) {
					contentStyle.height = this.$nextView.clientHeight + 'px';
				}
			}

			return _react2.default.createElement(
				'div',
				_extends({
					className: (0, _classnames2.default)('bmbo-date-picker', className),
					ref: this.setRef
				}, props),
				_react2.default.createElement(
					'div',
					{ className: 'bmbo-date-picker-header' },
					_react2.default.createElement('a', {
						role: 'button',
						tabIndex: -1,
						'aria-label': 'Prev Year',
						className: 'bmbo-date-picker-operation bmbo-year-prev',
						onClick: function onClick() {
							_this2.onSwitchDateView(viewDate.clone().setFullYear(viewDate.getFullYear() - 1));
						}
					}),
					_react2.default.createElement('a', {
						role: 'button',
						tabIndex: -1,
						'aria-label': 'Prev Month',
						className: 'bmbo-date-picker-operation bmbo-month-prev',
						onClick: function onClick() {
							_this2.onSwitchDateView(viewDate.clone().setMonth(viewDate.getMonth() - 1));
						}
					}),
					viewDate.format('YYYY-MM'),
					_react2.default.createElement('a', {
						role: 'button',
						tabIndex: -1,
						'aria-label': 'Next Year',
						className: 'bmbo-date-picker-operation bmbo-year-next',
						onClick: function onClick() {
							_this2.onSwitchDateView(viewDate.clone().setFullYear(viewDate.getFullYear() + 1));
						}
					}),
					_react2.default.createElement('a', {
						role: 'button',
						tabIndex: -1,
						'aria-label': 'Next Month',
						className: 'bmbo-date-picker-operation bmbo-month-next',
						onClick: function onClick() {
							_this2.onSwitchDateView(viewDate.clone().setMonth(viewDate.getMonth() + 1));
						}
					})
				),
				_react2.default.createElement(
					'ul',
					{ className: 'bmbo-date-picker-title' },
					DATE_LIST.map(function (str) {
						return _react2.default.createElement(
							'li',
							{ key: str },
							_react2.default.createElement(
								'strong',
								null,
								str
							)
						);
					})
				),
				_react2.default.createElement(
					'div',
					{
						className: (0, _classnames2.default)('bmbo-date-picker-content', {
							'bmbo-none': animateStatus === _uiUtil.ANIMATE_STATUS_NONE,
							'bmbo-showing': isShowing
						}),
						style: contentStyle
					},
					$view,
					$nextView
				)
			);
		}
	}]);

	return DatePicker;
}(_react2.default.Component);

DatePicker.propTypes = {
	value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.object]),
	className: _propTypes2.default.string,
	onChange: _propTypes2.default.func
};

exports.default = DatePicker;