'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _uiUtil = require('../utils/uiUtil');

var _Sequence = require('../utils/Sequence');

var _Sequence2 = _interopRequireDefault(_Sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Box = function (_React$Component) {
	_inherits(Box, _React$Component);

	function Box() {
		_classCallCheck(this, Box);

		var _this = _possibleConstructorReturn(this, (Box.__proto__ || Object.getPrototypeOf(Box)).call(this));

		_this.onTransitionEnd = function (event) {
			if (_this.state.animateStatus === _uiUtil.ANIMATE_STATUS_HIDING && event.target === _this.$ele) {
				_this.seq.next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_NONE });
				});
			}
		};

		_this.setRef = function (ele) {
			_this.$ele = ele;

			// Let window event handler ignore this element
			if (_this.$ele) _this.$ele._bmbo_ignore = true;
		};

		_this.checkUpdate = function (prevProps, nextProps) {
			if (!prevProps.visible === !nextProps.visible) return;

			var onVisibilityChanged = nextProps.onVisibilityChanged;


			if (nextProps.visible) {
				_this.seq.next(function (done) {
					var rect = nextProps.rect,
					    stretch = nextProps.stretch;


					_this.setState({
						animateStatus: _uiUtil.ANIMATE_STATUS_INIT,
						x: 0,
						y: 0,
						width: stretch ? rect.width : null
					}, done);
				}, { frame: 1 }).next(function (done) {
					var rect = nextProps.rect;

					var pinRect = _this.$ele.getBoundingClientRect();

					if (onVisibilityChanged) {
						onVisibilityChanged(true);
					}

					_this.setState(_extends({
						animateStatus: _uiUtil.ANIMATE_STATUS_SHOWING
					}, (0, _uiUtil.getEnablePosition)(rect, pinRect, 'b')), done);
				}, { frame: 1 }).next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_SHOWN });
				});
			} else {
				_this.seq.next(function (done) {
					_this.setState({
						animateStatus: _uiUtil.ANIMATE_STATUS_HIDING
					}, done);
				}, { frame: 1 }).next(function () {
					if (onVisibilityChanged) {
						onVisibilityChanged(false);
					}
				}, { delay: 0 }).next(function () {
					/** Reset to none status.
      ** This will not trigger if `onTransitionEnd` works.
      */
					_this.setState({
						animateStatus: _uiUtil.ANIMATE_STATUS_NONE
					});
				}, { delay: 3000 });
			}
		};

		_this.state = {
			animateStatus: _uiUtil.ANIMATE_STATUS_NONE,
			x: 0,
			y: 0,
			width: null
		};

		_this.seq = new _Sequence2.default();
		return _this;
	}

	_createClass(Box, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.checkUpdate({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.checkUpdate(this.props, nextProps);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.seq.destroy();
		}
	}, {
		key: 'render',
		value: function render() {
			var _state = this.state,
			    animateStatus = _state.animateStatus,
			    x = _state.x,
			    y = _state.y,
			    width = _state.width,
			    direct = _state.direct;

			if (animateStatus === _uiUtil.ANIMATE_STATUS_NONE) return null;

			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['children', 'className']);

			delete props.visible;
			delete props.rect;
			delete props.stretch;
			delete props.onVisibilityChanged;

			var style = {
				left: x + 'px',
				top: y + 'px'
			};

			if (width !== null) {
				style.width = width + 'px';
			}

			return (0, _uiUtil.createPortal)(_react2.default.createElement(
				'div',
				_extends({}, props, {

					style: style,
					className: (0, _classnames2.default)('bmbo-pin-box', {
						'bmbo-init': animateStatus === _uiUtil.ANIMATE_STATUS_INIT,
						'bmbo-showing': animateStatus === _uiUtil.ANIMATE_STATUS_SHOWING,
						'bmbo-hiding': animateStatus === _uiUtil.ANIMATE_STATUS_HIDING
					}, 'bmbo-' + direct, className),
					onTransitionEnd: this.onTransitionEnd,
					ref: this.setRef
				}),
				children
			));
		}
	}]);

	return Box;
}(_react2.default.Component);

Box.propTypes = {
	visible: _propTypes2.default.bool,
	rect: _propTypes2.default.object,
	stretch: _propTypes2.default.bool,
	onVisibilityChanged: _propTypes2.default.func,

	children: _propTypes2.default.node,
	className: _propTypes2.default.string
};

exports.default = Box;