'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _uiUtil = require('../utils/uiUtil');

var _Sequence = require('../utils/Sequence');

var _Sequence2 = _interopRequireDefault(_Sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ARROW_DES = 5;

var Tooltip = function (_React$Component) {
	_inherits(Tooltip, _React$Component);

	function Tooltip() {
		_classCallCheck(this, Tooltip);

		var _this = _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call(this));

		_this.onTransitionEnd = function (event) {
			if (_this.state.animateStatus === _uiUtil.ANIMATE_STATUS_HIDING && event.target === _this.$holder) {
				_this.seq.next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_NONE });
				});
			}
		};

		_this.setHolderRef = function (ele) {
			_this.$holder = ele;
		};

		_this.checkUpdate = function (prevProps, nextProps) {
			if (!prevProps.visible === !nextProps.visible) return;

			if (nextProps.visible) {
				_this.seq.next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_INIT, x: 0, y: 0 });
				}).next(function () {
					var rect = _this.props.rect;

					if (!_this.$holder) return;

					var ps = void 0;
					switch (nextProps.placement) {
						case 'bottom':
							ps = 'b,lr';
							break;
						case 'left':
							ps = 'l,tb';
							break;
						case 'right':
							ps = 'r,tb';
							break;
						default:
							ps = 't,lr';
					}

					var left = rect.left,
					    width = rect.width,
					    top = rect.top,
					    height = rect.height;

					var tgtRect = _this.$holder.getBoundingClientRect();

					var _getEnablePosition = (0, _uiUtil.getEnablePosition)({
						left: left - ARROW_DES,
						top: top - ARROW_DES,
						width: width + 2 * ARROW_DES,
						height: height + 2 * ARROW_DES
					}, tgtRect, ps),
					    _x = _getEnablePosition._x,
					    _y = _getEnablePosition._y,
					    pos = _objectWithoutProperties(_getEnablePosition, ['_x', '_y']);

					var arrowOffsetX = _x - pos.x;
					var arrowOffsetY = _y - pos.y;

					_this.setState(_extends({
						animateStatus: _uiUtil.ANIMATE_STATUS_SHOWING
					}, pos, {
						arrowOffsetX: arrowOffsetX,
						arrowOffsetY: arrowOffsetY
					}));
				}).next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_SHOWN });
				});
			} else {
				_this.seq.next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_HIDING });
				}).next(function () {
					_this.setState({ animateStatus: _uiUtil.ANIMATE_STATUS_NONE });
				}, { delay: 1000 });
			}
		};

		_this.state = {
			animateStatus: _uiUtil.ANIMATE_STATUS_NONE,
			x: 0,
			y: 0
		};
		_this.seq = new _Sequence2.default();
		return _this;
	}

	_createClass(Tooltip, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.checkUpdate({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.checkUpdate(this.props, nextProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    placement = _props.placement,
			    maxWidth = _props.maxWidth;
			var _state = this.state,
			    animateStatus = _state.animateStatus,
			    x = _state.x,
			    y = _state.y,
			    arrowOffsetX = _state.arrowOffsetX,
			    arrowOffsetY = _state.arrowOffsetY;


			if (animateStatus === _uiUtil.ANIMATE_STATUS_NONE) return null;

			return (0, _uiUtil.createPortal)(_react2.default.createElement(
				'div',
				{
					className: (0, _classnames2.default)('bmbo-tooltip', {
						'bmbo-hidden': animateStatus === _uiUtil.ANIMATE_STATUS_INIT,
						'bmbo-showing': animateStatus === _uiUtil.ANIMATE_STATUS_SHOWING,
						'bmbo-hiding': animateStatus === _uiUtil.ANIMATE_STATUS_HIDING
					}, 'bmbo-' + (placement || 'top')),
					style: { left: x + 'px', top: y + 'px' },
					ref: this.setHolderRef,
					onTransitionEnd: this.onTransitionEnd
				},
				_react2.default.createElement(
					'div',
					{
						className: 'bmbo-tooltip-title',
						style: { maxWidth: maxWidth && maxWidth + 'px' }
					},
					children
				),
				_react2.default.createElement('div', {
					className: 'bmbo-tooltip-arrow',
					style: { marginLeft: arrowOffsetX + 'px', marginTop: arrowOffsetY + 'px' }
				})
			));
		}
	}]);

	return Tooltip;
}(_react2.default.Component);

Tooltip.propTypes = {
	visible: _propTypes2.default.bool,
	maxWidth: _propTypes2.default.number,
	rect: _propTypes2.default.object,
	children: _propTypes2.default.node,
	placement: _propTypes2.default.string
};

exports.default = Tooltip;