'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Tooltip = require('./Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TooltipHolder = function (_React$Component) {
	_inherits(TooltipHolder, _React$Component);

	function TooltipHolder() {
		_classCallCheck(this, TooltipHolder);

		var _this = _possibleConstructorReturn(this, (TooltipHolder.__proto__ || Object.getPrototypeOf(TooltipHolder)).call(this));

		_this.onMouseEnter = function (event) {
			var rect = event.currentTarget.getBoundingClientRect();
			_this.setState({ hover: true, rect: rect });
		};

		_this.onMouseLeave = function () {
			_this.setState({ hover: false });
		};

		_this.state = {
			hover: false
		};
		return _this;
	}

	_createClass(TooltipHolder, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    title = _props.title,
			    children = _props.children,
			    placement = _props.placement,
			    maxWidth = _props.maxWidth,
			    className = _props.className,
			    inject = _props.inject,
			    props = _objectWithoutProperties(_props, ['title', 'children', 'placement', 'maxWidth', 'className', 'inject']);

			var _state = this.state,
			    hover = _state.hover,
			    rect = _state.rect;


			if (inject) {
				var childList = _react2.default.Children.map(children, function (node) {
					return _react2.default.cloneElement(node, {
						onMouseEnter: _this2.onMouseEnter,
						onMouseLeave: _this2.onMouseLeave,
						ref: _this2.setHolderRef
					});
				});

				return childList.concat(_react2.default.createElement(
					_Tooltip2.default,
					{ key: 'bmbo-tooltip', visible: hover, rect: rect, placement: placement, maxWidth: maxWidth },
					title
				));
			}

			return _react2.default.createElement(
				'div',
				_extends({
					className: (0, _classnames2.default)('bmbo-tooltip-holder', className),
					onMouseEnter: this.onMouseEnter,
					onMouseLeave: this.onMouseLeave
				}, props),
				children,
				_react2.default.createElement(
					_Tooltip2.default,
					{ visible: hover, rect: rect, placement: placement, maxWidth: maxWidth },
					title
				)
			);
		}
	}]);

	return TooltipHolder;
}(_react2.default.Component);

TooltipHolder.propTypes = {
	className: _propTypes2.default.string,
	title: _propTypes2.default.node,
	children: _propTypes2.default.node,
	placement: _propTypes2.default.string,
	maxWidth: _propTypes2.default.number,
	inject: _propTypes2.default.bool
};

exports.default = TooltipHolder;