'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _uiUtil = require('./uiUtil');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TaskHolder = function () {
	function TaskHolder(config) {
		_classCallCheck(this, TaskHolder);

		this.config = config;
		this.list = [];
		this.index = 0;
		this.promise = null;
	}

	_createClass(TaskHolder, [{
		key: 'weakThan',
		value: function weakThan() {
			var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			return (this.config.priority || 0) <= (config.priority || 0);
		}
	}, {
		key: 'next',
		value: function next(callback) {
			var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

			this.list.push({ callback: callback, config: config });
			return this;
		}
	}, {
		key: 'getCurrent',
		value: function getCurrent() {
			return this.list[this.index];
		}
	}, {
		key: 'nextStep',
		value: function nextStep() {
			this.index += 1;
		}
	}]);

	return TaskHolder;
}();

var Sequence = function () {
	function Sequence() {
		_classCallCheck(this, Sequence);

		this.taskHolder = null;
		this._destroy = false;
	}

	_createClass(Sequence, [{
		key: 'next',
		value: function next(callback) {
			var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

			var taskHolder = new TaskHolder(config);
			taskHolder.next(callback, config);

			if (!this.taskHolder || this.taskHolder.weakThan(config)) {
				this.taskHolder = taskHolder;
			}

			taskHolder.promise = this._doAction(taskHolder);

			return taskHolder;
		}
	}, {
		key: 'stop',
		value: function stop() {
			this.taskHolder = null;
		}
	}, {
		key: 'destroy',
		value: function destroy() {
			this._destroy = true;
		}
	}, {
		key: '_doAction',
		value: function _doAction(taskHolder) {
			var _this = this;

			return new Promise(function (resolve, reject) {
				if (_this._destroy) return;

				var step = function step() {
					var task = taskHolder.getCurrent();
					if (!task) {
						_this.taskHolder = null;
						resolve();
						return;
					}

					var exec = function exec() {
						try {
							if (_this.taskHolder !== taskHolder || _this._destroy) return;

							var taskCallback = task.callback;
							var needCallback = taskCallback.length !== 0;

							// Do next
							var doNext = function doNext() {
								// If is a looper
								if (task.config.loop) {
									step();
									return;
								}

								// Next task
								taskHolder.nextStep();
								step();
							};

							// Execute task
							var taskResult = taskCallback(doNext);
							if (taskResult === false) {
								_this.taskHolder = null;
								resolve();
								return;
							}

							if (!needCallback) {
								doNext();
							}
						} catch (err) {
							reject(err);
						}
					};

					if (task.config.delay !== undefined) {
						setTimeout(exec, task.config.delay);
					} else {
						(0, _uiUtil.requestAnimationFrame)(exec, task.config.frame || 2);
					}
				};

				step();
			});
		}
	}]);

	return Sequence;
}();

exports.default = Sequence;