'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.toArray = exports.equals = undefined;

var _pathUtil = require('./pathUtil');

var equals = exports.equals = function equals() {
	var list1 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	var list2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
	var path = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

	var len = list1.length;
	if (len !== list2.length) return false;

	for (var i = 0; i < len; i += 1) {
		var item1 = (0, _pathUtil.getValue)(list1[i], path);
		var item2 = (0, _pathUtil.getValue)(list2[i], path);
		if (item1 !== item2) return false;
	}

	return true;
};

var toArray = exports.toArray = function toArray(value) {
	if (Array.isArray(value)) return value;
	if (!value) return [];
	return [value];
};