'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.toDate = toDate;
exports.parseDate = parseDate;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FUNC_LIST = ['getFullYear', 'getMonth', 'getDate', 'getDay', 'getHours', 'getMinutes', 'getSeconds', 'getTime', { name: 'setFullYear', returnThis: true }, { name: 'setMonth', returnThis: true }, { name: 'setDate', returnThis: true }, { name: 'setHours', returnThis: true }, { name: 'setMinutes', returnThis: true }, { name: 'setSeconds', returnThis: true }, 'toString', 'toISOString'];

function toDate(date) {
	if (date === undefined || date === null) return null;

	var myDate = date;
	var type = typeof date === 'undefined' ? 'undefined' : _typeof(date);

	switch (type) {
		case 'number':
		case 'string':
			if (date === '') {
				myDate = new Date();
			} else {
				myDate = new Date(date);
			}
			break;
	}

	if (myDate._isAMomentObject) {
		// Process if is moment object
		myDate = new Date();
		myDate.setFullYear(myDate.year(), myDate.month(), myDate.date());
		myDate.setHours(myDate.hour(), myDate.minute(), myDate.second());

		return myDate;
	} else if (myDate instanceof Date) {
		return myDate;
	}

	return null;
}

/**
 * Wrap a simple Date class like light version of moment.
 */

var BambooDate = function () {
	function BambooDate() {
		_classCallCheck(this, BambooDate);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		var myArgs = args.length === 0 ? [''] : args;
		this.date = toDate.apply(undefined, myArgs);
	}

	_createClass(BambooDate, [{
		key: 'setDay',
		value: function setDay(target) {
			var currentDay = this.date.getDay();
			var distance = target - currentDay;
			this.date.setDate(this.date.getDate() + distance);
			return this;
		}
	}, {
		key: 'clone',
		value: function clone() {
			return new BambooDate(this.getTime());
		}
	}, {
		key: 'format',
		value: function format() {
			var _format = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

			return _format.replace(/YYYY/g, this.getFullYear()).replace(/MM/g, String(this.getMonth() + 1).padStart(2, '0')).replace(/DD/g, String(this.getDate()).padStart(2, '0')).replace(/HH/g, String(this.getHours()).padStart(2, '0')).replace(/mm/g, String(this.getMinutes()).padStart(2, '0')).replace(/SS/g, String(this.getSeconds()).padStart(2, '0'));
		}
	}]);

	return BambooDate;
}();

// Pass origin date function


exports.BambooDate = BambooDate;
FUNC_LIST.forEach(function (func) {
	var config = typeof func === 'string' ? { name: func } : func;

	BambooDate.prototype[config.name] = function dateFunc() {
		var _date;

		var returnValue = (_date = this.date)[config.name].apply(_date, arguments);

		if (config.returnThis) return this;
		return returnValue;
	};
});

function parseDate(date) {
	var myDate = toDate(date);
	if (myDate === null) return null;

	return {
		year: myDate.getFullYear(),
		month: myDate.getMonth(),
		date: myDate.getDate(),
		hour: myDate.getHours(),
		minute: myDate.getMinutes()
	};
}