var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var Button = function (_React$Component) {
	_inherits(Button, _React$Component);

	function Button() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Button);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Button.__proto__ || Object.getPrototypeOf(Button)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Button, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    disabled = _props.disabled,
			    size = _props.size,
			    transparent = _props.transparent,
			    checked = _props.checked,
			    props = _objectWithoutProperties(_props, ['children', 'className', 'disabled', 'size', 'transparent', 'checked']);

			var type = this.props.type || 'primary';

			delete props.type;
			delete props.onClick;

			return React.createElement(
				'button',
				_extends({
					className: classNames('bmbo-button', type && 'bmbo-' + type, disabled && 'bmbo-disabled', 'bmbo-' + (size || 'md'), transparent && 'bmbo-transparent', checked && 'bmbo-checked', className),
					onClick: this.onClick

				}, props),
				children
			);
		}
	}]);

	return Button;
}(React.Component);

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.onClick = function () {
		var _props2 = _this2.props,
		    onClick = _props2.onClick,
		    disabled = _props2.disabled;


		if (disabled) return;
		if (onClick) onClick.apply(undefined, arguments);
	};
};

Button.propTypes = {
	children: PropTypes.node,

	type: PropTypes.string,
	className: PropTypes.string,
	size: PropTypes.string,
	disabled: PropTypes.bool,
	onClick: PropTypes.func,
	transparent: PropTypes.bool,
	checked: PropTypes.bool
};

export default Button;