var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { ANIMATE_STATUS_NONE, ANIMATE_STATUS_SHOWING, ANIMATE_STATUS_SHOWN, ANIMATE_STATUS_HIDING, enableWinScrollBar, disableWinScrollBar } from '../utils/uiUtil';
import Sequence from '../utils/Sequence';

var Curtain = function (_React$Component) {
	_inherits(Curtain, _React$Component);

	function Curtain() {
		_classCallCheck(this, Curtain);

		var _this = _possibleConstructorReturn(this, (Curtain.__proto__ || Object.getPrototypeOf(Curtain)).call(this));

		_this.onTransitionEnd = function (event) {
			if (_this.state.animateStatus === ANIMATE_STATUS_HIDING && _this.$curtain === event.target) {
				_this.seq.next(function () {
					enableWinScrollBar('Curtain');
					_this.setState({ animateStatus: ANIMATE_STATUS_NONE });
				});
			}
		};

		_this.setCurtainRef = function (ele) {
			_this.$curtain = ele;
		};

		_this.checkUpdate = function (prevProps, nextProps) {
			if (!prevProps.visible === !nextProps.visible) return;

			if (nextProps.visible) {
				_this.seq.next(function () {
					disableWinScrollBar('Curtain');
					_this.setState({ animateStatus: ANIMATE_STATUS_SHOWING });
				}).next(function () {
					_this.setState({ animateStatus: ANIMATE_STATUS_SHOWN });
				});
			} else {
				_this.seq.next(function () {
					_this.setState({ animateStatus: ANIMATE_STATUS_HIDING });
				}).next(function () {
					enableWinScrollBar('Curtain');
					_this.setState({ animateStatus: ANIMATE_STATUS_NONE });
				}, { delay: 1000 });
			}
		};

		_this.state = {
			animateStatus: ANIMATE_STATUS_NONE
		};
		_this.seq = new Sequence();
		return _this;
	}

	_createClass(Curtain, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.checkUpdate({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.checkUpdate(this.props, nextProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    onClose = _props.onClose,
			    props = _objectWithoutProperties(_props, ['children', 'className', 'onClose']);

			var animateStatus = this.state.animateStatus;


			if (animateStatus === ANIMATE_STATUS_NONE) return null;

			delete props.visible;

			return React.createElement(
				'div',
				_extends({
					className: classNames('bmbo-curtain', {
						'bmbo-showing': animateStatus === ANIMATE_STATUS_SHOWING,
						'bmbo-hiding': animateStatus === ANIMATE_STATUS_HIDING
					}, className),

					ref: this.setCurtainRef,
					onTransitionEnd: this.onTransitionEnd
				}, props),
				React.createElement(
					'div',
					{ className: 'bmbo-curtain-content-holder' },
					React.createElement(
						'div',
						{ className: 'bmbo-curtain-content' },
						children,
						onClose && React.createElement('a', {
							role: 'button',
							tabIndex: -1,
							onClick: onClose,
							className: 'bmbo-curtain-close bmbo-times'
						})
					)
				)
			);
		}
	}]);

	return Curtain;
}(React.Component);

Curtain.propTypes = {
	visible: PropTypes.bool,
	children: PropTypes.node,
	className: PropTypes.string,
	onClose: PropTypes.func
};

export default Curtain;