var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

import Sequence from '../utils/Sequence';

var DynamicString = function (_React$Component) {
	_inherits(DynamicString, _React$Component);

	function DynamicString() {
		_classCallCheck(this, DynamicString);

		var _this = _possibleConstructorReturn(this, (DynamicString.__proto__ || Object.getPrototypeOf(DynamicString)).call(this));

		_this.doAnimation = function (props) {
			var value = props.value,
			    duration = props.duration,
			    step = props.step;

			var currentValue = _this.state.current;

			// Ignore if value not change
			if (value === currentValue) {
				_this.seq.stop();
				return;
			}

			var totalLen = currentValue.length + value.length;
			if (totalLen === 0) {
				// Skip if not word left
				_this.seq.stop();
				_this.setState({ current: '' });
				return;
			}

			var hidePtg = currentValue.length / totalLen;

			if (step) {
				// Use step
				var myStep = Math.ceil(Math.abs(step));
				if (isNaN(myStep) || myStep === 0) myStep = 1;

				var hiding = true;
				var current = currentValue;
				_this.seq.next(function () {
					if (hiding) {
						var len = Math.max(0, current.length - step);
						current = current.slice(0, len);
						_this.setState({ current: current });

						if (len === 0) hiding = false;
					} else {
						current = value.slice(0, current.length + step);
						_this.setState({ current: current });

						if (current.length === value.length) return false;
					}

					return null;
				}, {
					loop: true
				});
			} else {
				// Use duration
				var startTime = Date.now();
				_this.seq.next(function () {
					var currentTime = Date.now();
					var distance = currentTime - startTime;

					if (distance >= duration) {
						_this.setState({ current: value });
						return false;
					}

					var ptg = distance / duration;
					if (ptg < hidePtg) {
						var desPtg = (hidePtg - ptg) / hidePtg;
						_this.setState({
							current: currentValue.slice(0, Math.floor(currentValue.length * desPtg))
						});
					} else {
						var _desPtg = (ptg - hidePtg) / (1 - hidePtg);
						_this.setState({ current: value.slice(0, Math.floor(value.length * _desPtg)) });
					}

					return null;
				}, {
					loop: true
				});
			}
		};

		_this.state = {
			current: ''
		};

		_this.seq = new Sequence();
		return _this;
	}

	_createClass(DynamicString, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.doAnimation(this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.doAnimation(nextProps);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.seq.destroy();
		}
	}, {
		key: 'render',
		value: function render() {
			var current = this.state.current;

			var _props = this.props,
			    cursor = _props.cursor,
			    props = _objectWithoutProperties(_props, ['cursor']);

			delete props.value;
			delete props.duration;
			delete props.step;

			return React.createElement(
				'span',
				props,
				current,
				cursor && React.createElement('span', { className: 'bmbo-text-cursor' })
			);
		}
	}]);

	return DynamicString;
}(React.Component);

DynamicString.propTypes = {
	value: PropTypes.string,
	duration: PropTypes.number,
	step: PropTypes.number,
	cursor: PropTypes.bool
};

DynamicString.defaultProps = {
	duration: 1000
};

export default DynamicString;