var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { toArray } from '../utils/arrayUtil';
import { wrapperEventValue } from '../utils/eventUtil';

var FlatList = function (_React$Component) {
	_inherits(FlatList, _React$Component);

	function FlatList() {
		_classCallCheck(this, FlatList);

		var _this = _possibleConstructorReturn(this, (FlatList.__proto__ || Object.getPrototypeOf(FlatList)).call(this));

		_this.onItemClick = function (event, level, itemValue) {
			var _this$props = _this.props,
			    value = _this$props.value,
			    onChange = _this$props.onChange;


			var myValue = toArray(value).slice(0, level);
			myValue[level] = itemValue;

			if (onChange) {
				onChange(wrapperEventValue(event, _this.$ele, myValue));
			}
		};

		_this.setRef = function (ele) {
			_this.$ele = ele;
		};

		_this.getMaxLevel = function () {
			return _this.props.columns || _this.state.maxLevel;
		};

		_this.getList = function () {
			var level = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
			var _this$props$list = _this.props.list,
			    list = _this$props$list === undefined ? [] : _this$props$list;
			var levelLists = _this.state.levelLists;


			if (level === 0) return list;

			return levelLists[level] || [];
		};

		_this.refreshList = function (prevProps, nextProps) {
			if (prevProps.value === nextProps.value && prevProps.list === nextProps.list) return;

			var _nextProps$list = nextProps.list,
			    list = _nextProps$list === undefined ? [] : _nextProps$list;

			var levelLists = {};
			var valueList = toArray(nextProps.value);

			var current = list;

			var _loop = function _loop(i) {
				var currentValue = valueList[i];
				current = current.find(function (_ref) {
					var value = _ref.value;
					return value === currentValue;
				});

				if (!current) {
					// Skip if path not match
					return 'break';
				}

				current = current.list || [];
				levelLists[i + 1] = current;
			};

			for (var i = 0; i < valueList.length; i += 1) {
				var _ret = _loop(i);

				if (_ret === 'break') break;
			}

			_this.setState({ levelLists: levelLists });
		};

		_this.state = {
			maxLevel: 1,
			levelLists: {}
		};
		return _this;
	}

	_createClass(FlatList, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.refreshList({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.refreshList(this.props, nextProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    size = _props.size,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['size', 'className']);

			delete props.value;
			delete props.list;
			delete props.multi;
			delete props.columns;
			delete props.onChange;

			var myValue = toArray(this.props.value);

			return React.createElement(
				'div',
				_extends({}, props, {
					className: classNames('bmbo-flat-list', 'bmbo-' + (size || 'md'), className),
					ref: this.setRef
				}),
				new Array(this.getMaxLevel()).fill(0).map(function (_, level) {
					var list = _this2.getList(level);
					var levelValue = myValue[level];

					return React.createElement(
						'ul',
						{
							key: level,
							className: 'bmbo-flat-list-column'
						},
						list.map(function (_ref2) {
							var title = _ref2.title,
							    value = _ref2.value;
							return React.createElement(
								'li',
								{
									className: classNames('bmbo-flat-list-item', levelValue === value && 'bmbo-active'),
									key: value
								},
								React.createElement(
									'span',
									{
										className: 'bmbo-padding',
										role: 'button',
										tabIndex: -1,
										onClick: function onClick(event) {
											_this2.onItemClick(event, level, value);
										}
									},
									title || value
								)
							);
						})
					);
				})
			);
		}
	}]);

	return FlatList;
}(React.Component);

FlatList.propTypes = {
	value: PropTypes.node,
	list: PropTypes.array,
	multi: PropTypes.array,
	columns: PropTypes.number,
	onChange: PropTypes.func,

	size: PropTypes.string,
	className: PropTypes.string
};

export default FlatList;