var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { BAMBOO_COMPONENT } from '../utils/componentUtil';

export var BAMBOO_FORM_CHECKBOX = 'BAMBOO_FORM_CHECKBOX';

var Checkbox = function Checkbox(_ref) {
	var children = _ref.children,
	    checked = _ref.checked,
	    disabled = _ref.disabled,
	    size = _ref.size,
	    onClick = _ref.onClick,
	    className = _ref.className,
	    props = _objectWithoutProperties(_ref, ['children', 'checked', 'disabled', 'size', 'onClick', 'className']);

	return React.createElement(
		'div',
		_extends({
			className: classNames('bmbo-checkbox', 'bmbo-' + (size || 'md'), checked && 'bmbo-checked', disabled && 'bmbo-disabled', className),
			role: 'button',
			tabIndex: 0,
			onClick: disabled ? null : onClick
		}, props),
		React.createElement('input', { type: 'checkbox', checked: checked, disabled: disabled, readOnly: true }),
		React.createElement('span', { className: 'bmbo-checkbox-check' }),
		React.createElement(
			'div',
			{ className: 'bmbo-checkbox-content' },
			children
		)
	);
};

Checkbox.propTypes = {
	children: PropTypes.node,
	className: PropTypes.string,
	size: PropTypes.string,
	disabled: PropTypes.bool,

	checked: PropTypes.bool,
	onClick: PropTypes.func
};

Checkbox[BAMBOO_COMPONENT] = BAMBOO_FORM_CHECKBOX;

export default Checkbox;