var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { BAMBOO_INTERNAL_REF } from '../utils/componentUtil';

import Icon from '../Icon';

export var BAMBOO_FORM_INPUT = 'BAMBOO_FORM_INPUT';

var Input = function (_React$PureComponent) {
	_inherits(Input, _React$PureComponent);

	function Input() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Input);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Input.__proto__ || Object.getPrototypeOf(Input)).call.apply(_ref, [this].concat(args))), _this), _this.setRef = function (ele) {
			var setRef = _this.props[BAMBOO_INTERNAL_REF];
			_this.$input = ele;

			if (setRef) setRef(ele);
		}, _this.focus = function () {
			if (_this.$input) {
				_this.$input.focus();
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Input, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    size = _props.size,
			    type = _props.type,
			    icon = _props.icon,
			    className = _props.className,
			    rest = _objectWithoutProperties(_props, ['size', 'type', 'icon', 'className']);

			delete rest[BAMBOO_INTERNAL_REF];

			var $input = React.createElement('input', _extends({
				className: classNames('bmbo-input', icon && 'bmbo-with-icon', 'bmbo-' + (size || 'md'), type && 'bmbo-' + type, className),
				ref: this.setRef
			}, rest));

			if (icon) {
				return React.createElement(
					'div',
					{
						className: classNames('bmbo-input-container', 'bmbo-' + (size || 'md'))
					},
					$input,
					React.createElement(Icon, { name: icon, size: size, className: 'bmbo-input-icon' })
				);
			}

			return $input;
		}
	}]);

	return Input;
}(React.PureComponent);

Input.propTypes = {
	size: PropTypes.string,
	type: PropTypes.string,
	icon: PropTypes.string,
	className: PropTypes.string
};

Input[BAMBOO_FORM_INPUT] = BAMBOO_FORM_INPUT;

export default Input;