var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { BAMBOO_COMPONENT } from '../utils/componentUtil';
import { wrapperEventValue } from '../utils/eventUtil';

export var BAMBOO_FORM_RADIO = 'BAMBOO_FORM_RADIO';

var Radio = function (_React$Component) {
	_inherits(Radio, _React$Component);

	function Radio() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Radio);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Radio.__proto__ || Object.getPrototypeOf(Radio)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Radio, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    checked = _props.checked,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['children', 'checked', 'className']);

			delete props.checked;
			delete props.onClick;
			delete props.onChange;
			delete props.value;

			return React.createElement(
				'div',
				_extends({
					className: classNames('bmbo-radio', checked && 'bmbo-checked', className),
					role: 'button',
					tabIndex: 0,
					onClick: this.onClick
				}, props),
				React.createElement('input', { type: 'radio', checked: checked, readOnly: true }),
				React.createElement('span', { className: 'bmbo-radio-check' }),
				React.createElement(
					'div',
					{ className: 'bmbo-radio-content' },
					children
				)
			);
		}
	}]);

	return Radio;
}(React.Component);

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.onClick = function () {
		var _props2 = _this2.props,
		    onClick = _props2.onClick,
		    onChange = _props2.onChange,
		    value = _props2.value,
		    children = _props2.children;

		var event = arguments.length <= 0 ? undefined : arguments[0];

		if (onClick) onClick.apply(undefined, arguments);
		if (onChange) {
			onChange(wrapperEventValue(event, event.target, value !== undefined ? value : children));
		}
	};
};

Radio.propTypes = {
	children: PropTypes.node,
	className: PropTypes.string,

	checked: PropTypes.bool,
	onClick: PropTypes.func,
	onChange: PropTypes.func,
	value: PropTypes.node
};

Radio[BAMBOO_COMPONENT] = BAMBOO_FORM_RADIO;

export default Radio;