var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { wrapperEventValue } from '../utils/eventUtil';
import { toArray } from '../utils/arrayUtil';

import Caret from '../Icon/Caret';
import CheckBox from '../Form/Checkbox';
import PinBox from '../PinBox';
import SelectOption from './SelectOption';
import SelectGroup, { getValueList, getNodeList } from './SelectGroup';

function getTitle(optionList, value) {
	var option = optionList.find(function (opt) {
		return opt.value === value;
	});
	if (!option) return null;

	return option.title;
}

var Select = function (_React$Component) {
	_inherits(Select, _React$Component);

	function Select() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Select);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Select.__proto__ || Object.getPrototypeOf(Select)).call.apply(_ref, [this].concat(args))), _this), _this.onSelectValue = function (value, event) {
			var _this$props = _this.props,
			    onChange = _this$props.onChange,
			    multi = _this$props.multi,
			    oriValue = _this$props.value;


			var newValue = void 0;
			if (multi) {
				newValue = oriValue;
				if (!Array.isArray(newValue)) {
					newValue = newValue ? [newValue] : [];
				}

				if (newValue.includes(value)) {
					newValue = newValue.filter(function (v) {
						return v !== value;
					});
				} else {
					newValue = [].concat(_toConsumableArray(newValue), [value]);
				}
			} else {
				newValue = value;
			}

			if (onChange) {
				onChange(wrapperEventValue(event, _this.$ele, newValue));
			}

			if (!multi && _this.$pin) {
				_this.$pin.setVisible(false);
			}
		}, _this.onSelectValues = function (event, valueList, checked) {
			var _this$props2 = _this.props,
			    children = _this$props2.children,
			    value = _this$props2.value,
			    onChange = _this$props2.onChange;

			var myList = valueList || getValueList(children);
			var myChecked = checked !== undefined ? checked : !_this.isAllValueChecked();
			var newValue = [].concat(_toConsumableArray(toArray(value)));

			if (myChecked) {
				myList.forEach(function (val) {
					if (!newValue.includes(val)) {
						newValue.push(val);
					}
				});
			} else {
				newValue = newValue.filter(function (val) {
					return !myList.includes(val);
				});
			}

			if (onChange) {
				onChange(wrapperEventValue(event, _this.$ele, newValue));
			}
		}, _this.onSelectAllValue = function (event) {
			_this.onSelectValues(event);
		}, _this.setRef = function (ele) {
			_this.$ele = ele;
		}, _this.setPinRef = function (ele) {
			_this.$pin = ele;
		}, _this.isValueChecked = function (val) {
			var value = _this.props.value;

			return toArray(value).includes(val);
		}, _this.isAllValueChecked = function () {
			var _this$props3 = _this.props,
			    value = _this$props3.value,
			    children = _this$props3.children;

			var myValue = toArray(value);

			var allValueList = getValueList(children);
			return allValueList.every(function (val) {
				return myValue.includes(val);
			});
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Select, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return {
				bmboSelectSize: this.props.size,
				bmboSelectMulti: this.props.multi,
				bmboSelectDisabled: this.props.disabled,
				bmboOnSelectValue: this.onSelectValue,
				bmboOnSelectValues: this.onSelectValues,
				bmboSelectIsChecked: this.isValueChecked,
				bmboSelectIsAllChecked: this.isAllValueChecked
			};
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    disabled = _props.disabled,
			    size = _props.size,
			    title = _props.title,
			    className = _props.className,
			    value = _props.value,
			    multi = _props.multi,
			    flatten = _props.flatten,
			    noSelectAll = _props.noSelectAll,
			    children = _props.children,
			    props = _objectWithoutProperties(_props, ['disabled', 'size', 'title', 'className', 'value', 'multi', 'flatten', 'noSelectAll', 'children']);

			delete props.onChange;

			// =============================== Value ===============================
			var optionList = getNodeList(children);

			var $value = void 0;
			if (title !== undefined) {
				$value = title || '\xA0';
			} else if (multi) {
				var valueList = toArray(value);
				$value = React.createElement(
					'ul',
					{ className: 'bmbo-list-inline' },
					valueList.map(function (val) {
						return React.createElement(
							'li',
							{ key: val },
							getTitle(optionList, val)
						);
					}),
					!valueList.length && React.createElement(
						'li',
						null,
						'\xA0'
					)
				);
			} else {
				$value = getTitle(optionList, value) || '\xA0';
			}

			// ================================ List ===============================
			var canSelectAll = !noSelectAll && optionList.every(function (opt) {
				return !opt.disabled;
			});

			var $list = React.createElement(
				'ul',
				{
					className: classNames('bmbo-select-list', 'bmbo-list-unstyled', 'bmbo-' + (size || 'md'))
				},
				multi && canSelectAll && React.createElement(
					'li',
					{
						className: 'bmbo-select-item bmbo-padding bmbo-select-item-all',
						onClick: this.onSelectAllValue,
						role: 'button',
						tabIndex: -1
					},
					React.createElement(
						CheckBox,
						{ size: size, checked: this.isAllValueChecked() },
						'Select All'
					)
				),
				children
			);

			// =============================== Render ==============================
			if (multi && flatten) {
				return React.createElement(
					'div',
					_extends({
						className: classNames('bmbo-select', 'bmbo-select-flatten', disabled && 'bmbo-disabled')
					}, props, {
						ref: this.setRef
					}),
					$list
				);
			}

			return React.createElement(
				PinBox,
				{ pin: $list, ref: this.setPinRef, disabled: disabled, backdrop: true, stretch: true },
				React.createElement(
					'div',
					_extends({
						className: classNames('bmbo-select', disabled && 'bmbo-disabled')
					}, props, {
						ref: this.setRef
					}),
					React.createElement(
						'div',
						{
							className: classNames('bmbo-select-value', 'bmbo-' + (size || 'md'), className),

							role: 'button',
							tabIndex: 0
						},
						$value,
						React.createElement(Caret, { direct: 'down' })
					)
				)
			);
		}
	}]);

	return Select;
}(React.Component);

Select.propTypes = {
	onChange: PropTypes.func,
	size: PropTypes.string,
	className: PropTypes.string,
	title: PropTypes.node,
	value: PropTypes.any,
	children: PropTypes.node,
	multi: PropTypes.bool,
	disabled: PropTypes.bool,
	noSelectAll: PropTypes.bool,
	flatten: PropTypes.bool
};

Select.childContextTypes = {
	bmboSelectSize: PropTypes.string,
	bmboSelectMulti: PropTypes.bool,
	bmboSelectDisabled: PropTypes.bool,
	bmboSelectIsChecked: PropTypes.func,
	bmboSelectIsAllChecked: PropTypes.func,
	bmboOnSelectValue: PropTypes.func,
	bmboOnSelectValues: PropTypes.func
};

Select.Option = SelectOption;
Select.Group = SelectGroup;

export default Select;