var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { BAMBOO_COMPONENT } from '../utils/componentUtil';

import Checkbox from './Checkbox';

export var BAMBOO_FORM_SELECT_OPTION = 'BAMBOO_FORM_SELECT_OPTION';

var SelectOption = function (_React$Component) {
	_inherits(SelectOption, _React$Component);

	function SelectOption() {
		_classCallCheck(this, SelectOption);

		var _this = _possibleConstructorReturn(this, (SelectOption.__proto__ || Object.getPrototypeOf(SelectOption)).call(this));

		_this.onClick = function () {
			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			var _this$props = _this.props,
			    onClick = _this$props.onClick,
			    value = _this$props.value,
			    children = _this$props.children;
			var bmboOnSelectValue = _this.context.bmboOnSelectValue;


			var myVal = value !== undefined ? value : children;

			if (bmboOnSelectValue) bmboOnSelectValue.apply(undefined, [myVal].concat(args));
			if (onClick) onClick.apply(undefined, args);
		};

		_this.state = {};
		return _this;
	}

	_createClass(SelectOption, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    disabled = _props.disabled,
			    value = _props.value,
			    children = _props.children,
			    props = _objectWithoutProperties(_props, ['disabled', 'value', 'children']);

			var _context = this.context,
			    bmboSelectMulti = _context.bmboSelectMulti,
			    bmboSelectDisabled = _context.bmboSelectDisabled,
			    bmboSelectSize = _context.bmboSelectSize,
			    bmboSelectIsChecked = _context.bmboSelectIsChecked;


			var myDisabled = void 0;
			if (disabled !== undefined) {
				myDisabled = disabled;
			} else if (bmboSelectDisabled !== undefined) {
				myDisabled = bmboSelectDisabled;
			}

			var $children = children;
			if (bmboSelectMulti) {
				$children = React.createElement(
					Checkbox,
					{
						size: bmboSelectSize,
						checked: bmboSelectIsChecked(value === undefined ? children : value),
						disabled: myDisabled
					},
					children
				);
			}

			return React.createElement(
				'li',
				_extends({
					role: 'button',
					tabIndex: -1,
					className: classNames('bmbo-select-item bmbo-padding', myDisabled && 'bmbo-disabled')
				}, props, {
					onClick: myDisabled ? null : this.onClick
				}),
				$children
			);
		}
	}]);

	return SelectOption;
}(React.Component);

SelectOption.propTypes = {
	onClick: PropTypes.func,
	children: PropTypes.node,
	value: PropTypes.node,
	disabled: PropTypes.bool
};

SelectOption.contextTypes = {
	bmboSelectSize: PropTypes.string,
	bmboSelectMulti: PropTypes.bool,
	bmboSelectDisabled: PropTypes.bool,
	bmboOnSelectValue: PropTypes.func,
	bmboSelectIsChecked: PropTypes.func
};

SelectOption[BAMBOO_COMPONENT] = BAMBOO_FORM_SELECT_OPTION;

export default SelectOption;