var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { BAMBOO_COMPONENT } from '../utils/componentUtil';
import { wrapperEventValue } from '../utils/eventUtil';

import Button from '../Button';
import { BAMBOO_FORM_RADIO } from '../Form/Radio';

export var BAMBOO_GROUP_ITEM = 'BAMBOO_GROUP_ITEM';

var Item = function (_React$Component) {
	_inherits(Item, _React$Component);

	function Item() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Item);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Item.__proto__ || Object.getPrototypeOf(Item)).call.apply(_ref, [this].concat(args))), _this), _this.setRef = function (ele) {
			_this.$ele = ele;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Item, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    _props$style = _props.style,
			    style = _props$style === undefined ? {} : _props$style,
			    width = _props.width,
			    children = _props.children,
			    isFirst = _props.isFirst,
			    isLast = _props.isLast,
			    value = _props.value,
			    onChange = _props.onChange,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['style', 'width', 'children', 'isFirst', 'isLast', 'value', 'onChange', 'className']);

			if (width) style.width = width;

			var $child = React.Children.only(children);

			if (React.isValidElement($child) && $child.type && $child.type[BAMBOO_COMPONENT] === BAMBOO_FORM_RADIO) {
				var _$child$props = $child.props,
				    _onClick = _$child$props.onClick,
				    type = _$child$props.type,
				    transparent = _$child$props.transparent,
				    restProps = _objectWithoutProperties(_$child$props, ['onClick', 'type', 'transparent']);

				var checked = restProps.value === value;

				$child = React.createElement(Button, _extends({
					checked: checked,
					type: checked || !transparent ? type : 'weak',
					transparent: transparent
				}, restProps, {
					ref: this.setRef,
					onClick: function onClick() {
						var event = arguments.length <= 0 ? undefined : arguments[0];
						if (onChange) onChange(wrapperEventValue(event, _this2.$ele, restProps.value));
						if (_onClick) _onClick.apply(undefined, arguments);
					}
				}));
			}

			return React.createElement(
				'div',
				_extends({
					className: classNames('bmbo-group-item', {
						'bmbo-first': isFirst && !isLast,
						'bmbo-last': isLast && !isFirst,
						'bmbo-middle': !isFirst && !isLast,
						className: className
					}),
					style: style
				}, props),
				$child
			);
		}
	}]);

	return Item;
}(React.Component);

Item.propTypes = {
	children: PropTypes.node,
	className: PropTypes.string,
	style: PropTypes.object,
	width: PropTypes.string,
	isFirst: PropTypes.bool,
	isLast: PropTypes.bool,
	value: PropTypes.node,
	onChange: PropTypes.func
};

Item[BAMBOO_COMPONENT] = BAMBOO_GROUP_ITEM;

export default Item;