var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { BAMBOO_COMPONENT, mapChildrenForNode } from '../utils/componentUtil';
import Item, { BAMBOO_GROUP_ITEM } from './Item';

var Group = function Group(_ref) {
	var children = _ref.children,
	    value = _ref.value,
	    onChange = _ref.onChange,
	    _ref$style = _ref.style,
	    style = _ref$style === undefined ? {} : _ref$style,
	    width = _ref.width,
	    className = _ref.className,
	    props = _objectWithoutProperties(_ref, ['children', 'value', 'onChange', 'style', 'width', 'className']);

	var myStyle = _extends({}, style);
	if (width) myStyle.width = width;

	// Wrap component with Item
	var itemList = mapChildrenForNode(children, function (node) {
		var item = node;
		if (!node.type || node.type[BAMBOO_COMPONENT] !== BAMBOO_GROUP_ITEM) {
			item = React.createElement(
				Item,
				null,
				node
			);
		}

		return item;
	}).filter(function (n) {
		return n;
	});
	var count = itemList.length;

	// Mark first & last Item
	var $children = itemList.map(function (node, index) {
		return React.cloneElement(node, {
			isFirst: index === 0,
			isLast: index === count - 1,
			value: value,
			onChange: onChange
		});
	});

	return React.createElement(
		'div',
		_extends({
			className: classNames('bmbo-group', className),
			style: myStyle
		}, props),
		$children
	);
};

Group.propTypes = {
	children: PropTypes.node,
	className: PropTypes.string,
	value: PropTypes.node,
	onChange: PropTypes.func,
	style: PropTypes.object,
	width: PropTypes.string
};

Group.Item = Item;

export default Group;