import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import Loading from './Loading';
import Caret from './Caret';
import Search from './Search';

var Icon = function Icon(_ref) {
	var name = _ref.name,
	    spin = _ref.spin,
	    className = _ref.className;
	return React.createElement('span', { className: classNames('fa fa-' + name + ' bmbo-icon', spin && 'fa-spin', className) });
};

Icon.propTypes = {
	name: PropTypes.string,
	spin: PropTypes.bool,
	className: PropTypes.string
};

Icon.Loading = Loading;
Icon.Caret = Caret;
Icon.Search = Search;

export default Icon;