var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var Label = function Label(_ref) {
	var type = _ref.type,
	    size = _ref.size,
	    className = _ref.className,
	    children = _ref.children,
	    props = _objectWithoutProperties(_ref, ['type', 'size', 'className', 'children']);

	return React.createElement(
		'span',
		_extends({
			className: classNames('bmbo-label', 'bmbo-' + (type || 'primary'), 'bmbo-' + (size || 'md'), className)
		}, props),
		children
	);
};

Label.propTypes = {
	children: PropTypes.node,

	type: PropTypes.string,
	className: PropTypes.string,
	size: PropTypes.string,
	disabled: PropTypes.bool,
	onClick: PropTypes.func,
	transparent: PropTypes.bool,
	checked: PropTypes.bool
};

export default Label;