var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import Caret from '../Icon/Caret';
import MenuList from './MenuList';

var MenuItem = function (_React$Component) {
	_inherits(MenuItem, _React$Component);

	function MenuItem() {
		_classCallCheck(this, MenuItem);

		var _this = _possibleConstructorReturn(this, (MenuItem.__proto__ || Object.getPrototypeOf(MenuItem)).call(this));

		_this.onClick = function () {
			var _this$props$item = _this.props.item,
			    disabled = _this$props$item.disabled,
			    onClick = _this$props$item.onClick;


			if (disabled) return;

			var hideMenu = _this.context.hideMenu;


			if (hideMenu) hideMenu();
			if (onClick) onClick.apply(undefined, arguments);
		};

		_this.onMouseDown = function (event) {
			event.preventDefault();
		};

		_this.onMouseEnter = function () {
			var list = _this.props.item.list;


			_this.setState({
				active: true
			});

			if (!list) return;

			var rect = _this.$item.getBoundingClientRect();

			_this.setState({
				drillDown: list,
				rect: rect
			});
		};

		_this.onMouseLeave = function () {
			_this.setState({
				active: false,
				drillDown: null
			});
		};

		_this.setRef = function (ele) {
			_this.$item = ele;
		};

		_this.state = {
			drillDown: undefined,
			rect: undefined,
			active: false
		};
		return _this;
	}

	_createClass(MenuItem, [{
		key: 'render',
		value: function render() {
			var _props$item = this.props.item,
			    separator = _props$item.separator,
			    title = _props$item.title,
			    disabled = _props$item.disabled,
			    list = _props$item.list;
			var _state = this.state,
			    drillDown = _state.drillDown,
			    _state$rect = _state.rect;
			_state$rect = _state$rect === undefined ? {} : _state$rect;
			var left = _state$rect.left,
			    top = _state$rect.top,
			    width = _state$rect.width,
			    height = _state$rect.height,
			    active = _state.active;


			if (separator) {
				return React.createElement('li', { className: 'bmbo-separator' });
			}

			return React.createElement(
				'li',
				{
					className: classNames('bmbo-menu-item', disabled && 'bmbo-disabled', !disabled && active && 'bmbo-active'),
					role: 'button',
					tabIndex: -1,
					ref: this.setRef,
					onClick: this.onClick,
					onMouseDown: this.onMouseDown,
					onMouseEnter: this.onMouseEnter,
					onMouseLeave: this.onMouseLeave
				},
				title,
				list && React.createElement(Caret, null),
				drillDown && React.createElement(MenuList, {
					list: drillDown,
					x: left,
					y: top - 1,
					width: width,
					height: height
				})
			);
		}
	}]);

	return MenuItem;
}(React.Component);

MenuItem.propTypes = {
	item: PropTypes.object
};

MenuItem.contextTypes = {
	hideMenu: PropTypes.func
};

export default MenuItem;