var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import classNames from 'classnames';
import PropTypes from 'prop-types';

import { ANIMATE_STATUS_NONE, ANIMATE_STATUS_SHOWING, ANIMATE_STATUS_SHOWN, getEnablePosition, createPortal } from '../utils/uiUtil';
import Sequence from '../utils/Sequence';

import MenuItem from './MenuItem';

var MenuList = function (_React$Component) {
	_inherits(MenuList, _React$Component);

	function MenuList() {
		_classCallCheck(this, MenuList);

		var _this = _possibleConstructorReturn(this, (MenuList.__proto__ || Object.getPrototypeOf(MenuList)).call(this));

		_this.onMouseDown = function (event) {
			event.stopPropagation();
		};

		_this.setRef = function (ele) {
			_this.$list = ele;
		};

		_this.state = {
			animateStatus: ANIMATE_STATUS_NONE
		};
		_this.seq = new Sequence();
		return _this;
	}

	_createClass(MenuList, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this2 = this;

			var _props = this.props,
			    x = _props.x,
			    y = _props.y,
			    _props$width = _props.width,
			    width = _props$width === undefined ? 0 : _props$width,
			    _props$height = _props.height,
			    height = _props$height === undefined ? 0 : _props$height;

			var rect = this.$list.getBoundingClientRect();

			this.seq.next(function () {
				_this2.setState(_extends({}, getEnablePosition({ left: x, top: y, width: width, height: height }, rect, 'r'), {
					animateStatus: ANIMATE_STATUS_SHOWING
				}));
			}).next(function () {
				_this2.setState({
					animateStatus: ANIMATE_STATUS_SHOWN
				});
			});
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.seq.destroy();
		}
	}, {
		key: 'render',
		value: function render() {
			var _props$list = this.props.list,
			    list = _props$list === undefined ? [] : _props$list;
			var menuSize = this.context.menuSize;
			var _state = this.state,
			    x = _state.x,
			    y = _state.y,
			    animateStatus = _state.animateStatus;


			return createPortal(React.createElement(
				'ul',
				{
					ref: this.setRef,
					className: classNames('bmbo-box-absolute', 'bmbo-menu-list', {
						'bmbo-hidden': animateStatus === ANIMATE_STATUS_NONE,
						'bmbo-showing': animateStatus === ANIMATE_STATUS_SHOWING
					}, 'bmbo-' + (menuSize || 'md')),
					style: { left: x + 'px', top: y + 'px' },
					role: 'presentation',
					tabIndex: -1,
					onMouseDown: this.onMouseDown
				},
				list.map(function (item, index) {
					if (!item) return null;
					return React.createElement(MenuItem, { key: index, item: item });
				})
			));
		}
	}]);

	return MenuList;
}(React.Component);

MenuList.propTypes = {
	list: PropTypes.array,
	x: PropTypes.number,
	y: PropTypes.number,
	width: PropTypes.number,
	height: PropTypes.number
};

MenuList.contextTypes = {
	menuSize: PropTypes.string
};

export default MenuList;