var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { canUseDOM } from '../utils/envUtil';

import MenuList from './MenuList';

var $currentMenu = void 0;

if (canUseDOM) {
	window.addEventListener('mousedown', function () {
		if ($currentMenu) {
			$currentMenu.hideMenu();
			$currentMenu = null;
		}
	});
}

var Menu = function (_React$Component) {
	_inherits(Menu, _React$Component);

	function Menu() {
		_classCallCheck(this, Menu);

		var _this = _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).call(this));

		_this.onContextMenu = function (event) {
			event.preventDefault();

			_this.setState({
				show: true,
				x: event.clientX,
				y: event.clientY
			});

			$currentMenu = _this;
		};

		_this.hideMenu = function (callback) {
			_this.setState({
				show: false
			}, callback);
		};

		_this.state = {
			show: false,
			x: 0,
			y: 0
		};
		return _this;
	}

	_createClass(Menu, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return {
				hideMenu: this.hideMenu,
				menuSize: this.props.size
			};
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    _props$menu = _props.menu,
			    menu = _props$menu === undefined ? [] : _props$menu,
			    children = _props.children,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['menu', 'children', 'className']);

			var _state = this.state,
			    show = _state.show,
			    x = _state.x,
			    y = _state.y;


			delete props.size;

			return React.createElement(
				'div',
				_extends({
					className: classNames('bmbo-menu-wrapper', className),
					onContextMenu: this.onContextMenu
				}, props),
				children,
				show && React.createElement(MenuList, { list: menu, x: x, y: y })
			);
		}
	}]);

	return Menu;
}(React.Component);

Menu.propTypes = {
	children: PropTypes.node,
	className: PropTypes.string,
	menu: PropTypes.array,
	size: PropTypes.string
};

Menu.childContextTypes = {
	hideMenu: PropTypes.func,
	menuSize: PropTypes.string
};

export default Menu;