var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

import Modal from './Modal';

var ModalFlexHolder = function (_React$Component) {
	_inherits(ModalFlexHolder, _React$Component);

	function ModalFlexHolder() {
		_classCallCheck(this, ModalFlexHolder);

		var _this = _possibleConstructorReturn(this, (ModalFlexHolder.__proto__ || Object.getPrototypeOf(ModalFlexHolder)).call(this));

		_this.showDialog = function (config) {
			_this.setState(function (_ref) {
				var list = _ref.list;
				return {
					list: [].concat(_toConsumableArray(list), [{
						visible: true,
						config: config
					}])
				};
			});
		};

		_this.lockDialog = function (index) {
			var lock = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

			_this.setState(function (_ref2) {
				var list = _ref2.list;

				var newList = list.concat();
				newList[index] = _extends({}, list[index], {
					lock: lock
				});

				return { list: newList };
			});
		};

		_this.hideDialog = function (index) {
			_this.setState(function (_ref3) {
				var list = _ref3.list;

				var newList = list.concat();
				newList[index] = _extends({}, list[index], {
					visible: false
				});

				return { list: newList };
			});
		};

		_this.removeDialog = function (index) {
			_this.setState(function (_ref4) {
				var list = _ref4.list;

				var dialog = list[index];
				return {
					list: list.filter(function (d) {
						return d !== dialog;
					})
				};
			});
		};

		_this.state = {
			list: []
		};
		return _this;
	}

	_createClass(ModalFlexHolder, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var list = this.state.list;


			return React.createElement(
				'div',
				null,
				list.map(function (dialog, index) {
					var config = dialog.config,
					    visible = dialog.visible,
					    lock = dialog.lock;
					var _onClose = config.onClose,
					    onConfirm = config.onConfirm;


					var closeWrapper = function closeWrapper(func) {
						var ret = void 0;
						if (func) ret = func();

						_this2.lockDialog(index, true);

						Promise.resolve(ret).then(function (close) {
							if (close === false) {
								_this2.lockDialog(index, false);
								return;
							}

							_this2.hideDialog(index);
						}).catch(function () {
							_this2.lockDialog(index, false);
						});
					};

					var props = {
						onClose: function onClose() {
							closeWrapper(_onClose);
						},
						onClosed: function onClosed() {
							_this2.removeDialog(index);
						}
					};

					if (onConfirm) {
						props.onConfirm = function () {
							closeWrapper(onConfirm);
						};
					}

					return React.createElement(Modal, _extends({
						key: index
					}, config, {

						visible: visible,
						lock: lock
					}, props));
				})
			);
		}
	}]);

	return ModalFlexHolder;
}(React.Component);

ModalFlexHolder.propTypes = {};

export default ModalFlexHolder;