var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { BAMBOO_COMPONENT } from '../utils/componentUtil';
import Icon from '../Icon';

export var BAMBOO_MODAL_LOADING = 'BAMBOO_MODAL_LOADING';

var ModalLoading = function ModalLoading(_ref) {
	var children = _ref.children,
	    loading = _ref.loading,
	    defaultView = _ref.defaultView,
	    className = _ref.className,
	    props = _objectWithoutProperties(_ref, ['children', 'loading', 'defaultView', 'className']);

	var $content = children;

	if (defaultView) {
		$content = React.createElement(
			'div',
			{ className: classNames('bmbo-default-loading') },
			React.createElement(Icon.Loading, null)
		);
	}

	return React.createElement(
		'div',
		_extends({
			className: classNames('bmbo-modal-loading', {
				'bmbo-shown': loading,
				className: className
			})
		}, props),
		$content
	);
};

ModalLoading.propTypes = {
	loading: PropTypes.bool,
	children: PropTypes.node,
	className: PropTypes.string,
	defaultView: PropTypes.bool
};

ModalLoading[BAMBOO_COMPONENT] = BAMBOO_MODAL_LOADING;

export default ModalLoading;