import React from 'react';
import { render } from 'react-dom';

import { canUseDOM } from '../utils/envUtil';

import ModalFlexHolder from './ModalFlexHolder';

import Modal from './Modal';

var BAMBOO_MODAL_FLEX_HOLDER = 'bmbo_modal_flex_holder';

var $modalFlexHolder = void 0;
if (canUseDOM) {
	// Clean up menu holder for hot module reload
	window.document.querySelectorAll('#' + BAMBOO_MODAL_FLEX_HOLDER).forEach(function (ele) {
		ele.remove();
	});

	// Set up menu holder
	var $flexHolder = window.document.createElement('div');
	$flexHolder.id = BAMBOO_MODAL_FLEX_HOLDER;

	render(React.createElement(ModalFlexHolder, {
		ref: function ref(node) {
			$modalFlexHolder = node;
		}
	}), $flexHolder);
}

Modal.showDialog = function (config) {
	if (!$modalFlexHolder) {
		console.error('[Modal] Flex holder not defined.(Isomorphic render?)');
		return;
	}

	$modalFlexHolder.showDialog(config);
};

export default Modal;