var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { isInRect } from '../utils/uiUtil';
import Caret from '../Icon/Caret';
import NavList from './NavList';

var NavGroup = function (_React$Component) {
	_inherits(NavGroup, _React$Component);

	function NavGroup() {
		_classCallCheck(this, NavGroup);

		var _this = _possibleConstructorReturn(this, (NavGroup.__proto__ || Object.getPrototypeOf(NavGroup)).call(this));

		_this.onMouseEnter = function () {
			var rect = _this.$item.getBoundingClientRect();
			_this.setState({ hover: true, rect: rect });
		};

		_this.onMouseLeave = function (event) {
			var clientX = event.clientX,
			    clientY = event.clientY;


			if (_this.$list) {
				var rect = _this.$list.getBoundingClientRect();

				// Chrome has the bug of click event will trigger mouse leave event
				// ref: https://stackoverflow.com/questions/45266854/mouseleave-triggered-by-click
				if (isInRect(clientX, clientY, rect)) {
					return;
				}
			}

			_this.setState({ hover: false });
		};

		_this.onClick = function () {
			_this.setState(function (_ref) {
				var open = _ref.open;
				return {
					open: !open
				};
			});
		};

		_this.setItemRef = function (ele) {
			_this.$item = ele;
		};

		_this.setListRef = function (ele) {
			_this.$list = ele;
		};

		_this.state = {
			hover: false,
			rect: null,

			open: false
		};
		return _this;
	}

	_createClass(NavGroup, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    title = _props.title,
			    children = _props.children,
			    active = _props.active,
			    disabled = _props.disabled,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['title', 'children', 'active', 'disabled', 'className']);

			var _context = this.context,
			    navVertical = _context.navVertical,
			    navInline = _context.navInline;
			var _state = this.state,
			    hover = _state.hover,
			    rect = _state.rect,
			    open = _state.open;


			return React.createElement(
				'li',
				_extends({
					className: classNames('bmbo-nav-group', hover && 'bmbo-hover', active && 'bmbo-active', disabled && 'bmbo-disabled', className),
					ref: this.setItemRef,
					onMouseEnter: this.onMouseEnter,
					onMouseLeave: this.onMouseLeave
				}, props),
				React.createElement(
					'div',
					{
						className: 'bmbo-nav-title',
						role: 'button',
						tabIndex: -1,
						onClick: this.onClick
					},
					title,
					navVertical && React.createElement(Caret, {
						direct: navInline && open ? 'down' : 'right'
					})
				),
				React.createElement(
					NavList,
					{
						visible: hover,
						rect: rect,
						setRef: this.setListRef,
						open: open
					},
					children
				)
			);
		}
	}]);

	return NavGroup;
}(React.Component);

NavGroup.propTypes = {
	className: PropTypes.string,
	title: PropTypes.node,
	children: PropTypes.node,
	active: PropTypes.bool,
	disabled: PropTypes.bool
};

NavGroup.contextTypes = {
	navVertical: PropTypes.bool,
	navInline: PropTypes.bool
};

export default NavGroup;