var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var NavItem = function NavItem(_ref) {
	var children = _ref.children,
	    onClick = _ref.onClick,
	    active = _ref.active,
	    disabled = _ref.disabled,
	    className = _ref.className,
	    props = _objectWithoutProperties(_ref, ['children', 'onClick', 'active', 'disabled', 'className']);

	return React.createElement(
		'li',
		_extends({
			className: classNames('bmbo-nav-item', active && 'bmbo-active', disabled && 'bmbo-disabled', className),
			role: 'button',
			tabIndex: -1,
			onClick: onClick
		}, props),
		children
	);
};

NavItem.propTypes = {
	children: PropTypes.node,
	onClick: PropTypes.func,
	className: PropTypes.string,

	active: PropTypes.bool,
	disabled: PropTypes.bool
};

export default NavItem;