var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import Button from '../Button';
import Group from '../Group';

var Pagination = function (_React$Component) {
	_inherits(Pagination, _React$Component);

	function Pagination() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Pagination);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Pagination.__proto__ || Object.getPrototypeOf(Pagination)).call.apply(_ref, [this].concat(args))), _this), _this.gotoPage = function (page) {
			var gotoPage = _this.props.gotoPage;

			if (gotoPage) gotoPage(page);
		}, _this.goPrevPage = function () {
			var page = _this.props.page;

			if (page > 1) _this.gotoPage(page - 1);
		}, _this.goNextPage = function () {
			var _this$props = _this.props,
			    page = _this$props.page,
			    count = _this$props.count,
			    pageSize = _this$props.pageSize;

			var totalPages = Math.ceil(count / pageSize);
			if (page < totalPages) _this.gotoPage(page + 1);
		}, _this.goFirstPage = function () {
			_this.gotoPage(1);
		}, _this.goLastPage = function () {
			var _this$props2 = _this.props,
			    count = _this$props2.count,
			    pageSize = _this$props2.pageSize;

			var totalPages = Math.ceil(count / pageSize);
			_this.gotoPage(totalPages);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Pagination, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    count = _props.count,
			    pageSize = _props.pageSize,
			    _props$page = _props.page,
			    page = _props$page === undefined ? 1 : _props$page,
			    _props$range = _props.range,
			    range = _props$range === undefined ? 9 : _props$range,
			    disabled = _props.disabled,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['count', 'pageSize', 'page', 'range', 'disabled', 'className']);

			delete props.gotoPage;

			var totalPages = Math.ceil(count / pageSize);

			var lRange = Math.floor((range - 1) / 2);
			var rRange = range - 1 - lRange;
			var minPage = page - lRange;
			var maxPage = page + rRange;

			if (minPage < 1) {
				maxPage += -minPage + 1;
				minPage = 1;
			}
			if (maxPage > totalPages) {
				minPage -= maxPage - totalPages;
				maxPage = totalPages;
			}
			if (minPage < 1) minPage = 1;

			var $navItems = [];
			var index = 0;

			var _loop = function _loop(i) {
				$navItems.push(React.createElement(
					Button,
					{
						key: index,
						disabled: disabled,
						onClick: function onClick() {
							_this2.gotoPage(i);
						},
						type: page === i ? 'primary' : 'weak',
						transparent: true
					},
					i
				));

				index += 1;
			};

			for (var i = minPage; i <= maxPage; i += 1) {
				_loop(i);
			}

			return React.createElement(
				Group,
				_extends({ className: classNames('bmbo-pagination', className) }, props),
				React.createElement(
					Button,
					{ type: 'weak', transparent: true, onClick: this.goFirstPage, disabled: page <= 1 || disabled },
					'\xAB'
				),
				React.createElement(
					Button,
					{ type: 'weak', transparent: true, onClick: this.goPrevPage, disabled: page <= 1 || disabled },
					'\u2039'
				),
				$navItems,
				React.createElement(
					Button,
					{ type: 'weak', transparent: true, onClick: this.goNextPage, disabled: page >= totalPages || disabled },
					'\u203A'
				),
				React.createElement(
					Button,
					{ type: 'weak', transparent: true, onClick: this.goLastPage, disabled: page >= totalPages || disabled },
					'\xBB'
				)
			);
		}
	}]);

	return Pagination;
}(React.Component);

Pagination.propTypes = {
	gotoPage: PropTypes.func,
	count: PropTypes.number.isRequired,
	page: PropTypes.number,
	pageSize: PropTypes.number,
	range: PropTypes.number,
	disabled: PropTypes.bool,
	className: PropTypes.string
};

export default Pagination;