var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var DatePanel = function DatePanel(_ref) {
	var date = _ref.date,
	    viewDate = _ref.viewDate,
	    startDate = _ref.startDate,
	    endDate = _ref.endDate,
	    triggerChangeEvent = _ref.triggerChangeEvent,
	    className = _ref.className,
	    setRef = _ref.setRef,
	    props = _objectWithoutProperties(_ref, ['date', 'viewDate', 'startDate', 'endDate', 'triggerChangeEvent', 'className', 'setRef']);

	var $dateList = [];
	var currentDate = startDate.clone();

	var _loop = function _loop() {
		var pointDate = currentDate.clone();

		$dateList.push(React.createElement(
			'li',
			{
				key: pointDate.format('YYYY-MM-DD'),
				className: classNames({
					'bmbo-deprecated': viewDate && pointDate.getMonth() !== viewDate.getMonth(),
					'bmbo-active': date && pointDate.getFullYear() === date.getFullYear() && pointDate.getMonth() === date.getMonth() && pointDate.getDate() === date.getDate()
				}),
				role: 'button',
				tabIndex: -1,
				onClick: function onClick(event) {
					triggerChangeEvent(event, pointDate);
				}
			},
			pointDate.getDate()
		));

		currentDate.setDate(currentDate.getDate() + 1);
	};

	while (currentDate.getTime() <= endDate.getTime()) {
		_loop();
	}

	return React.createElement(
		'ul',
		_extends({ className: classNames('bmbo-date-picker-panel', className), ref: setRef }, props),
		$dateList
	);
};

DatePanel.propTypes = {
	date: PropTypes.object,
	viewDate: PropTypes.object,
	startDate: PropTypes.object,
	endDate: PropTypes.object,
	className: PropTypes.string,
	triggerChangeEvent: PropTypes.func,
	setRef: PropTypes.func
};

export default DatePanel;