var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { findDOMNode } from 'react-dom';
import PropTypes from 'prop-types';

import { mapChildrenForNode } from '../utils/componentUtil';
import { addUniqueListener, removeUniqueListener, isSameSource } from '../utils/eventUtil';

import EmptyWrapper from '../EmptyWrapper';
import Box from './Box';

var PinBox = function (_React$Component) {
	_inherits(PinBox, _React$Component);

	function PinBox() {
		_classCallCheck(this, PinBox);

		var _this = _possibleConstructorReturn(this, (PinBox.__proto__ || Object.getPrototypeOf(PinBox)).call(this));

		_this.onBackdrop = function (event) {
			if (isSameSource(event, findDOMNode(_this.$ele))) return;

			_this.setState({ visible: false }, _this.onVisibilityChange);
			removeUniqueListener('mousedown', _this.onBackdrop);
		};

		_this.onClick = function () {
			var _this$props = _this.props,
			    backdrop = _this$props.backdrop,
			    disabled = _this$props.disabled;


			if (disabled) return;

			_this.setState(function (_ref) {
				var visible = _ref.visible;

				var newState = { visible: !visible };

				if (newState.visible && _this.$ele) {
					/** Use `findDOMNode` to support customize component.
      ** To avoid user need to support setRef for this component.
      **/
					newState.rect = findDOMNode(_this.$ele) // eslint-disable-line react/no-find-dom-node
					.getBoundingClientRect();

					if (backdrop) {
						addUniqueListener('mousedown', _this.onBackdrop);
					}
				}

				return newState;
			}, _this.onVisibilityChange);
		};

		_this.onVisibilityChange = function () {
			var onVisibilityChange = _this.props.onVisibilityChange;
			var visible = _this.state.visible;


			if (onVisibilityChange) onVisibilityChange(visible);
		};

		_this.setRef = function (ele) {
			_this.$ele = ele;
		};

		_this.setVisible = function (visible) {
			_this.setState({ visible: visible }, _this.onVisibilityChange);
		};

		_this.state = {
			visible: false
		};
		return _this;
	}

	_createClass(PinBox, [{
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			removeUniqueListener('mousedown', this.onBackdrop);
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    trigger = _props.trigger,
			    children = _props.children,
			    pin = _props.pin,
			    stretch = _props.stretch,
			    onVisibilityChanged = _props.onVisibilityChanged,
			    props = _objectWithoutProperties(_props, ['trigger', 'children', 'pin', 'stretch', 'onVisibilityChanged']);

			var _state = this.state,
			    visible = _state.visible,
			    rect = _state.rect;


			delete props.onVisibilityChange;
			delete props.backdrop;

			var $children = mapChildrenForNode(children, function (node) {
				var onClick = node.props.onClick,
				    _ref2 = node.ref;

				var newProps = {
					ref: function ref() {
						if (_ref2) _ref2.apply(undefined, arguments);
						_this2.setRef.apply(_this2, arguments);
					}
				};

				if (!trigger || trigger === 'click') {
					// Click Trigger
					newProps.onClick = function () {
						if (onClick) onClick.apply(undefined, arguments);
						_this2.onClick.apply(_this2, arguments);
					};
				} else {
					console.warn('[PinBox] Trigger not realize:', trigger);
				}

				// Transform children to class component to avoid stateless function can't use ref
				return React.createElement(
					EmptyWrapper,
					newProps,
					node
				);
			});

			return [].concat(_toConsumableArray($children), [pin ? React.createElement(
				Box,
				_extends({
					key: '__BMBO_PIN_BOX_BOX__'
				}, props, {
					visible: visible,
					rect: rect,
					stretch: stretch,
					onVisibilityChanged: onVisibilityChanged
				}),
				pin
			) : null]);
		}
	}]);

	return PinBox;
}(React.Component);

PinBox.propTypes = {
	trigger: PropTypes.string,
	backdrop: PropTypes.bool,
	stretch: PropTypes.bool,
	children: PropTypes.node,
	pin: PropTypes.node,
	disabled: PropTypes.bool,

	onVisibilityChange: PropTypes.func,
	onVisibilityChanged: PropTypes.func
};

export default PinBox;