var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var Progress = function (_React$Component) {
	_inherits(Progress, _React$Component);

	function Progress() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Progress);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Progress.__proto__ || Object.getPrototypeOf(Progress)).call.apply(_ref, [this].concat(args))), _this), _this.getPercentage = function () {
			var _this$props = _this.props,
			    min = _this$props.min,
			    max = _this$props.max,
			    value = _this$props.value;

			var myValue = value;
			if (myValue > max) myValue = max;
			if (myValue < min) myValue = min;
			return Math.floor((myValue - min) * 100 / (max - min));
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Progress, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    type = _props.type,
			    size = _props.size,
			    active = _props.active,
			    showMark = _props.showMark,
			    className = _props.className,
			    props = _objectWithoutProperties(_props, ['type', 'size', 'active', 'showMark', 'className']);

			var ptg = this.getPercentage();

			delete props.min;
			delete props.max;
			delete props.value;

			return React.createElement(
				'div',
				_extends({
					className: classNames('bmbo-progress', 'bmbo-' + (type || 'primary'), 'bmbo-' + (size || 'md'), active && 'bmbo-active', className),
					role: 'progressbar'
				}, props),
				React.createElement(
					'div',
					{ className: 'bmbo-progress-bar', style: { width: ptg + '%' } },
					showMark && React.createElement(
						'span',
						{ className: 'bmbo-mark' },
						ptg,
						'%'
					)
				)
			);
		}
	}]);

	return Progress;
}(React.Component);

Progress.propTypes = {
	className: PropTypes.string,
	min: PropTypes.number,
	max: PropTypes.number,
	value: PropTypes.number,

	type: PropTypes.string,
	size: PropTypes.string,
	active: PropTypes.bool,
	showMark: PropTypes.bool
};

Progress.defaultProps = {
	min: 0,
	max: 100,
	value: 100
};

export default Progress;