var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import { mapChildrenByType } from '../utils/componentUtil';
import { getValue } from '../utils/pathUtil';

import Column, { BAMBOO_TABLE_COLUMN } from './Column';
import Pagination from '../Pagination';

var Table = function (_React$Component) {
	_inherits(Table, _React$Component);

	function Table() {
		_classCallCheck(this, Table);

		var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this));

		_this.getPage = function () {
			var page = _this.props.page;

			return page === undefined ? _this.state.page : page;
		};

		_this.getCount = function () {
			var _this$props = _this.props,
			    count = _this$props.count,
			    data = _this$props.data;

			return count === undefined ? (data || []).length : count;
		};

		_this.getColumnList = function () {
			var children = _this.props.children;

			return mapChildrenByType(children, BAMBOO_TABLE_COLUMN);
		};

		_this.getList = function () {
			var _this$props2 = _this.props,
			    pageSize = _this$props2.pageSize,
			    page = _this$props2.page,
			    count = _this$props2.count,
			    data = _this$props2.data;
			var list = _this.state.list;


			if (page !== undefined && count !== undefined) {
				return data;
			}

			var myPage = _this.getPage();
			return list.slice((myPage - 1) * pageSize, myPage * pageSize);
		};

		_this.checkUpdate = function (prevProps, nextProps) {
			if (prevProps.data === nextProps.data) return;

			_this.setState({
				list: (nextProps.data || []).concat()
			}, function () {
				// TODO: Support sort function
			});
		};

		_this.gotoPage = function (page) {
			var onPageChange = _this.props.onPageChange;

			_this.setState({ page: page });

			if (onPageChange) onPageChange(page);
		};

		_this.state = {
			page: 1,
			list: []
		};
		return _this;
	}

	_createClass(Table, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.checkUpdate({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.checkUpdate(this.props, nextProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    className = _props.className,
			    pageSize = _props.pageSize,
			    bordered = _props.bordered,
			    hover = _props.hover,
			    onRowClick = _props.onRowClick,
			    props = _objectWithoutProperties(_props, ['className', 'pageSize', 'bordered', 'hover', 'onRowClick']);

			delete props.page;
			delete props.count;
			delete props.data;
			delete props.onPageChange;

			var page = this.getPage();

			var columnList = this.getColumnList().map(function (c) {
				return c.props;
			});
			var list = this.getList();

			return React.createElement(
				'div',
				{ className: 'bmbo-table-container' },
				React.createElement(
					'table',
					_extends({
						className: classNames('bmbo-table', bordered && 'bmbo-bordered', className)

					}, props),
					React.createElement(
						'colgroup',
						null,
						columnList.map(function (_ref, colIndex) {
							var width = _ref.width;
							return React.createElement('col', { key: colIndex, width: width });
						})
					),
					React.createElement(
						'thead',
						null,
						React.createElement(
							'tr',
							null,
							columnList.map(function (_ref2, colIndex) {
								var title = _ref2.title,
								    name = _ref2.name;
								return React.createElement(
									'td',
									{ key: colIndex },
									title || name
								);
							})
						)
					),
					React.createElement(
						'tbody',
						{ className: classNames(hover && 'bmbo-hover') },
						list.map(function (item, rowIndex) {
							var trProps = {};

							if (onRowClick) {
								trProps.role = 'button';
								trProps.tabIndex = -1;
								trProps.onClick = function () {
									onRowClick(item, rowIndex);
								};
							}

							return React.createElement(
								'tr',
								_extends({ key: rowIndex }, trProps),
								columnList.map(function (column, colIndex) {
									var name = column.name,
									    render = column.render,
									    colProps = _objectWithoutProperties(column, ['name', 'render']);

									delete colProps.width;

									return React.createElement(
										'td',
										_extends({ key: colIndex }, colProps),
										render ? render(item) : getValue(item, name)
									);
								})
							);
						})
					)
				),
				React.createElement(
					'div',
					{ className: 'bmbo-table-pagination' },
					React.createElement(Pagination, {
						page: page,
						pageSize: pageSize,
						count: this.getCount(),
						gotoPage: this.gotoPage
					})
				)
			);
		}
	}]);

	return Table;
}(React.Component);

Table.propTypes = {
	className: PropTypes.string,
	bordered: PropTypes.bool,
	hover: PropTypes.bool,
	children: PropTypes.node,

	data: PropTypes.array,
	page: PropTypes.number,
	count: PropTypes.number,
	pageSize: PropTypes.number,

	onPageChange: PropTypes.func,
	onRowClick: PropTypes.func
};

Table.defaultProps = {
	pageSize: 10
};

Table.Column = Column;

export default Table;