var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import classNames from 'classnames';
import PropTypes from 'prop-types';

import { ANIMATE_STATUS_NONE, ANIMATE_STATUS_INIT, ANIMATE_STATUS_SHOWING, ANIMATE_STATUS_SHOWN, ANIMATE_STATUS_HIDING, createPortal, getEnablePosition } from '../utils/uiUtil';
import Sequence from '../utils/Sequence';

var ARROW_DES = 5;

var Tooltip = function (_React$Component) {
	_inherits(Tooltip, _React$Component);

	function Tooltip() {
		_classCallCheck(this, Tooltip);

		var _this = _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call(this));

		_this.onTransitionEnd = function (event) {
			if (_this.state.animateStatus === ANIMATE_STATUS_HIDING && event.target === _this.$holder) {
				_this.seq.next(function () {
					_this.setState({ animateStatus: ANIMATE_STATUS_NONE });
				});
			}
		};

		_this.setHolderRef = function (ele) {
			_this.$holder = ele;
		};

		_this.checkUpdate = function (prevProps, nextProps) {
			if (!prevProps.visible === !nextProps.visible) return;

			if (nextProps.visible) {
				_this.seq.next(function () {
					_this.setState({ animateStatus: ANIMATE_STATUS_INIT, x: 0, y: 0 });
				}).next(function () {
					var rect = _this.props.rect;

					if (!_this.$holder) return;

					var ps = void 0;
					switch (nextProps.placement) {
						case 'bottom':
							ps = 'b,lr';
							break;
						case 'left':
							ps = 'l,tb';
							break;
						case 'right':
							ps = 'r,tb';
							break;
						default:
							ps = 't,lr';
					}

					var left = rect.left,
					    width = rect.width,
					    top = rect.top,
					    height = rect.height;

					var tgtRect = _this.$holder.getBoundingClientRect();

					var _getEnablePosition = getEnablePosition({
						left: left - ARROW_DES,
						top: top - ARROW_DES,
						width: width + 2 * ARROW_DES,
						height: height + 2 * ARROW_DES
					}, tgtRect, ps),
					    _x = _getEnablePosition._x,
					    _y = _getEnablePosition._y,
					    pos = _objectWithoutProperties(_getEnablePosition, ['_x', '_y']);

					var arrowOffsetX = _x - pos.x;
					var arrowOffsetY = _y - pos.y;

					_this.setState(_extends({
						animateStatus: ANIMATE_STATUS_SHOWING
					}, pos, {
						arrowOffsetX: arrowOffsetX,
						arrowOffsetY: arrowOffsetY
					}));
				}).next(function () {
					_this.setState({ animateStatus: ANIMATE_STATUS_SHOWN });
				});
			} else {
				_this.seq.next(function () {
					_this.setState({ animateStatus: ANIMATE_STATUS_HIDING });
				}).next(function () {
					_this.setState({ animateStatus: ANIMATE_STATUS_NONE });
				}, { delay: 1000 });
			}
		};

		_this.state = {
			animateStatus: ANIMATE_STATUS_NONE,
			x: 0,
			y: 0
		};
		_this.seq = new Sequence();
		return _this;
	}

	_createClass(Tooltip, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.checkUpdate({}, this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.checkUpdate(this.props, nextProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    placement = _props.placement,
			    maxWidth = _props.maxWidth;
			var _state = this.state,
			    animateStatus = _state.animateStatus,
			    x = _state.x,
			    y = _state.y,
			    arrowOffsetX = _state.arrowOffsetX,
			    arrowOffsetY = _state.arrowOffsetY;


			if (animateStatus === ANIMATE_STATUS_NONE) return null;

			return createPortal(React.createElement(
				'div',
				{
					className: classNames('bmbo-tooltip', {
						'bmbo-hidden': animateStatus === ANIMATE_STATUS_INIT,
						'bmbo-showing': animateStatus === ANIMATE_STATUS_SHOWING,
						'bmbo-hiding': animateStatus === ANIMATE_STATUS_HIDING
					}, 'bmbo-' + (placement || 'top')),
					style: { left: x + 'px', top: y + 'px' },
					ref: this.setHolderRef,
					onTransitionEnd: this.onTransitionEnd
				},
				React.createElement(
					'div',
					{
						className: 'bmbo-tooltip-title',
						style: { maxWidth: maxWidth && maxWidth + 'px' }
					},
					children
				),
				React.createElement('div', {
					className: 'bmbo-tooltip-arrow',
					style: { marginLeft: arrowOffsetX + 'px', marginTop: arrowOffsetY + 'px' }
				})
			));
		}
	}]);

	return Tooltip;
}(React.Component);

Tooltip.propTypes = {
	visible: PropTypes.bool,
	maxWidth: PropTypes.number,
	rect: PropTypes.object,
	children: PropTypes.node,
	placement: PropTypes.string
};

export default Tooltip;