var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import Tooltip from './Tooltip';

var TooltipHolder = function (_React$Component) {
	_inherits(TooltipHolder, _React$Component);

	function TooltipHolder() {
		_classCallCheck(this, TooltipHolder);

		var _this = _possibleConstructorReturn(this, (TooltipHolder.__proto__ || Object.getPrototypeOf(TooltipHolder)).call(this));

		_this.onMouseEnter = function (event) {
			var rect = event.currentTarget.getBoundingClientRect();
			_this.setState({ hover: true, rect: rect });
		};

		_this.onMouseLeave = function () {
			_this.setState({ hover: false });
		};

		_this.state = {
			hover: false
		};
		return _this;
	}

	_createClass(TooltipHolder, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    title = _props.title,
			    children = _props.children,
			    placement = _props.placement,
			    maxWidth = _props.maxWidth,
			    className = _props.className,
			    inject = _props.inject,
			    props = _objectWithoutProperties(_props, ['title', 'children', 'placement', 'maxWidth', 'className', 'inject']);

			var _state = this.state,
			    hover = _state.hover,
			    rect = _state.rect;


			if (inject) {
				var childList = React.Children.map(children, function (node) {
					return React.cloneElement(node, {
						onMouseEnter: _this2.onMouseEnter,
						onMouseLeave: _this2.onMouseLeave,
						ref: _this2.setHolderRef
					});
				});

				return childList.concat(React.createElement(
					Tooltip,
					{ key: 'bmbo-tooltip', visible: hover, rect: rect, placement: placement, maxWidth: maxWidth },
					title
				));
			}

			return React.createElement(
				'div',
				_extends({
					className: classNames('bmbo-tooltip-holder', className),
					onMouseEnter: this.onMouseEnter,
					onMouseLeave: this.onMouseLeave
				}, props),
				children,
				React.createElement(
					Tooltip,
					{ visible: hover, rect: rect, placement: placement, maxWidth: maxWidth },
					title
				)
			);
		}
	}]);

	return TooltipHolder;
}(React.Component);

TooltipHolder.propTypes = {
	className: PropTypes.string,
	title: PropTypes.node,
	children: PropTypes.node,
	placement: PropTypes.string,
	maxWidth: PropTypes.number,
	inject: PropTypes.bool
};

export default TooltipHolder;